#ifndef CREATEOGGDIALOG_H
#define CREATEOGGDIALOG_H

#include "OggFile.h"

//(*Headers(CreateOggDialog)
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/slider.h>
#include <wx/button.h>
#include <wx/dialog.h>
#include <wx/combobox.h>
//*)

class CreateOggDialog: public wxDialog
{
	public:

		CreateOggDialog(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~CreateOggDialog();
        wxString GetConvertedFilename() ;
        void addOggFile( wxString filename, int ogg_type, bool check_fof ) ;
        wxString GetDestDir( ) ;
        wxString GetSourceDir( ) ;
        void SetDestDir( wxString dir ) ;
        void SetSourceDir( wxString dir ) ;

        wxString m_converted_filename ;
        OggFile m_ogg_song ;
        OggFile m_ogg_guitar ;
        OggFile m_ogg_rhythm ;
        wxString m_src_dir ;
        wxString m_dest_dir ;

		//(*Declarations(CreateOggDialog)
		wxStaticText* StaticText10;
		wxStaticText* StaticText9;
		wxTextCtrl* TextCtrlDelay;
		wxStaticText* StaticText13;
		wxStaticText* StaticText2;
		wxStaticText* StaticText14;
		wxTextCtrl* TextCtrlTitle;
		wxComboBox* ComboGuitarR;
		wxButton* ButtonSetOutput;
		wxStaticText* StaticText6;
		wxStaticText* StaticText8;
		wxStaticText* StaticText11;
		wxComboBox* ComboRhythmR;
		wxStaticText* StaticText1;
		wxStaticText* StaticText3;
		wxSlider* SliderOggQuality;
		wxButton* ButtonCancel;
		wxCheckBox* CheckBoxDeferCreation;
		wxTextCtrl* TextCtrlOutputFile;
		wxComboBox* ComboSongL;
		wxButton* ButtonAddRhythm;
		wxStaticText* StaticText5;
		wxStaticText* StaticText7;
		wxButton* ButtonOk;
		wxComboBox* ComboRhythmL;
		wxStaticText* StaticText12;
		wxComboBox* ComboSongR;
		wxButton* ButtonAddGuitar;
		wxTextCtrl* TextCtrlArtist;
		wxStaticText* StaticText4;
		wxButton* ButtonAddSong;
		wxComboBox* ComboGuitarL;
		//*)

	protected:


		//(*Identifiers(CreateOggDialog)
		static const long ID_STATICTEXT1;
		static const long ID_COMBOBOX1;
		static const long ID_BUTTON1;
		static const long ID_STATICTEXT2;
		static const long ID_COMBOBOX2;
		static const long ID_STATICTEXT3;
		static const long ID_COMBOBOX3;
		static const long ID_BUTTON2;
		static const long ID_STATICTEXT4;
		static const long ID_COMBOBOX4;
		static const long ID_STATICTEXT5;
		static const long ID_COMBOBOX5;
		static const long ID_BUTTON3;
		static const long ID_STATICTEXT6;
		static const long ID_COMBOBOX6;
		static const long ID_STATICTEXT8;
		static const long ID_TEXTCTRL2;
		static const long ID_STATICTEXT9;
		static const long ID_TEXTCTRL3;
		static const long ID_STATICTEXT10;
		static const long ID_TEXTCTRL4;
		static const long ID_STATICTEXT14;
		static const long ID_SLIDER1;
		static const long ID_STATICTEXT7;
		static const long ID_TEXTCTRL1;
		static const long ID_BUTTON6;
		static const long ID_STATICTEXT11;
		static const long ID_CHECKBOX1;
		static const long ID_STATICTEXT12;
		static const long ID_STATICTEXT13;
		static const long ID_BUTTON4;
		static const long ID_BUTTON5;
		//*)

	private:

		//(*Handlers(CreateOggDialog)
		void OnButtonAddSongClick(wxCommandEvent& event);
		void OnButtonAddGuitarClick(wxCommandEvent& event);
		void OnButtonAddRhythmClick(wxCommandEvent& event);
		void OnButtonOkClick(wxCommandEvent& event);
		void OnButtonCancelClick(wxCommandEvent& event);
		void OnButtonSetOutputClick(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
