#ifndef MIDIFILE_H_INCLUDED
#define MIDIFILE_H_INCLUDED

#include <wx/arrstr.h>
#include "wxArrayStringArray.h"

class MidiFile
{


public:
    MidiFile (wxString FileName);
    ~MidiFile ();
    int writeGH2Format( wxString filename, int remove_orange, char has_coop ) ;
    void PrintNoteTrack( FILE *outfile, int trackno, char *trackname, int remove_orange  );
    void ReplicateTracks() ;
    void Replicate( int to, int from) ;


    bool isValid() ;

private:
    wxString IniFileName;
    wxArrayStringArray m_tracks ;
    wxString m_header ;
    wxArrayString m_track_names ;
    wxArrayString m_tempo_lines ;

    int m_maxseq ;
    bool m_is_gh1 ;
    int m_guitar_track ;
    int m_fallback_guitar_track ;
    int m_guitar_coop_track ;
    int m_guitar_bass_track ;
    int m_band_singer_track ;
    int m_band_drums_track ;
    int m_band_bass_track ;
    int m_events_track ;
    int m_triggers_track ;
    int m_tempo_track ;
    bool m_found_tempo ;
    bool m_found_timesig ;
    bool m_has_easy ;
    bool m_has_medium ;
    bool m_has_hard ;
    bool m_has_expert ;

};



#endif // MIDIFILE_H_INCLUDED
