
#define wxUSE_THREADS 1

#include "ProgressDialog.h"

#include <wx/msgdlg.h>
#include <wx/thread.h>
#include <wx/timer.h>

//(*InternalHeaders(ProgressDialog)
#include <wx/intl.h>
#include <wx/string.h>
//*)

//(*IdInit(ProgressDialog)
const long ProgressDialog::ID_GAUGE1 = wxNewId();
const long ProgressDialog::ID_STATICTEXT2 = wxNewId();
const long ProgressDialog::ID_GAUGE2 = wxNewId();
const long ProgressDialog::ID_STATICTEXT3 = wxNewId();
const long ProgressDialog::ID_BUTTON1 = wxNewId();
//*)


wxSemaphore g_semDialog;
wxSemaphore g_semProgress;
int g_current_gauge_value = 0 ;
int g_overall_gauge_value = 0 ;
int g_dialog_answer = 0 ;

DEFINE_EVENT_TYPE(wxEVT_DIALOG_EVENT)
DEFINE_EVENT_TYPE(wxEVT_CURRENT_PROGRESS_EVENT)
DEFINE_EVENT_TYPE(wxEVT_FINISHED_EVENT)
DEFINE_EVENT_TYPE(wxEVT_OVERALL_PROGRESS_EVENT)


BEGIN_EVENT_TABLE(ProgressDialog,wxDialog)
	//(*EventTable(ProgressDialog)
	//*)
    EVT_COMMAND  (-1, wxEVT_OVERALL_PROGRESS_EVENT, ProgressDialog::OnOverallProgressEvent)
    EVT_COMMAND  (-1, wxEVT_CURRENT_PROGRESS_EVENT, ProgressDialog::OnCurrentProgressEvent)
    EVT_COMMAND  (-1, wxEVT_FINISHED_EVENT, ProgressDialog::OnFinishedEvent)
    EVT_COMMAND  (-1, wxEVT_DIALOG_EVENT, ProgressDialog::OnDialogEvent)
    EVT_TIMER (wxID_ANY, ProgressDialog::OnTimer)
END_EVENT_TABLE()

ProgressThread::ProgressThread()
{
	Create();
}

void ProgressDialog::OnTimer( wxTimerEvent& evt )
{
    if ( ! m_running )
    {
        g_semProgress.Post() ;
        m_running = true;
        m_timer->Stop();
    }
}

wxThread::ExitCode ProgressThread::Entry()
{
    /*
    while ( ! g_done )
    {
        wxCommandEvent event( wxEVT_MY_EVENT, g_id );
        event.SetEventObject( g_dlg );
        // Give it some contents
        event.SetString( wxT("Hallo") );
        // Send it
        g_dlg->GetEventHandler()->ProcessEvent( event );
        Sleep( 1000 ) ;
    }

    g_running = false ;
*/
    return 0 ;
}

void ProgressDialog::OnCurrentProgressEvent( wxCommandEvent &event )
{
    GaugeCurrent->SetValue( event.GetInt()  ) ;
    StaticTextCurrent->SetLabel( event.GetString() ) ;

}

void ProgressDialog::OnOverallProgressEvent( wxCommandEvent &event )
{
    GaugeOverall->SetValue( event.GetInt() ) ;
    StaticTextOverall->SetLabel( event.GetString() ) ;

}

void ProgressDialog::OnDialogEvent( wxCommandEvent &event )
{
    g_dialog_answer = wxMessageBox( event.GetString(), _T("ARK File Too Large"), wxYES_NO ) ;
    g_semDialog.Post() ;

}

void ProgressDialog::OnFinishedEvent( wxCommandEvent &event )
{
    m_process_error = ( event.GetInt() != 0 ) ;

    if ( event.GetString().Length() > 0 )
    {
        wxMessageBox( event.GetString(), m_process_error ? wxT("Error") : wxT("") ) ;
    }
    m_done = true ;
    EndModal( wxOK ) ;

}

ProgressDialog::ProgressDialog(wxThread *thread, wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size)
{
	//(*Initialize(ProgressDialog)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer7;
	wxFlexGridSizer* FlexGridSizer8;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(7, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(0, 3, 0, 0);
	FlexGridSizer2->Add(0,0,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(2, 1, 0, 0);
	GaugeCurrent = new wxGauge(this, ID_GAUGE1, 100, wxDefaultPosition, wxSize(380,28), wxGA_HORIZONTAL, wxDefaultValidator, _T("ID_GAUGE1"));
	FlexGridSizer3->Add(GaugeCurrent, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	StaticTextCurrent = new wxStaticText(this, ID_STATICTEXT2, _("Curent job"), wxDefaultPosition, wxSize(535,17), wxALIGN_CENTRE, _T("ID_STATICTEXT2"));
	FlexGridSizer3->Add(StaticTextCurrent, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
	FlexGridSizer4->Add(0,0,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5 = new wxFlexGridSizer(2, 1, 0, 0);
	GaugeOverall = new wxGauge(this, ID_GAUGE2, 100, wxDefaultPosition, wxSize(380,28), wxGA_HORIZONTAL, wxDefaultValidator, _T("ID_GAUGE2"));
	FlexGridSizer5->Add(GaugeOverall, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	StaticTextOverall = new wxStaticText(this, ID_STATICTEXT3, _("Overall progress"), wxDefaultPosition, wxSize(535,17), wxALIGN_CENTRE, _T("ID_STATICTEXT3"));
	FlexGridSizer5->Add(StaticTextOverall, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6 = new wxFlexGridSizer(0, 3, 0, 0);
	FlexGridSizer1->Add(FlexGridSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7 = new wxFlexGridSizer(0, 3, 0, 0);
	FlexGridSizer1->Add(FlexGridSizer7, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer8 = new wxFlexGridSizer(0, 3, 0, 0);
	Button1 = new wxButton(this, ID_BUTTON1, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer8->Add(Button1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer8, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&ProgressDialog::OnButton1Click);
	//*)

	m_done = false ;
	m_running = false ;
	m_process_error = false ;

    m_timer = new wxTimer( this ) ;
    m_timer->Start( 100 ) ;

	thread->Run() ;

}

//int ProgressDialog::StartThread()
//{
//}

ProgressDialog::~ProgressDialog()
{
    m_done = true ;
    g_semProgress.Wait();
    m_done = true ;
//        m_timer->Stop();
}


void ProgressDialog::OnButton1Click(wxCommandEvent& event)
{
    m_done = true ;
    EndModal( wxCANCEL ) ;

}
