#ifndef PROGRESSDIALOG_H
#define PROGRESSDIALOG_H

//(*Headers(ProgressDialog)
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/dialog.h>
#include <wx/gauge.h>
//*)

#include <wx/timer.h>

DECLARE_EVENT_TYPE(wxEVT_DIALOG_EVENT, -1)
DECLARE_EVENT_TYPE(wxEVT_CURRENT_PROGRESS_EVENT, -1)
DECLARE_EVENT_TYPE(wxEVT_OVERALL_PROGRESS_EVENT, -1)
DECLARE_EVENT_TYPE(wxEVT_FINISHED_EVENT, -1)

class ProgressThread: public wxThread
{
	public:

		ProgressThread();
//		virtual ~ProgressThread();

		bool m_running ;
		bool m_done ;

	protected:

        virtual ExitCode Entry() ;

	private:

};

class ProgressDialog: public wxDialog
{
	public:

		ProgressDialog( wxThread *threads, wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~ProgressDialog();

		bool m_running ;
		bool m_done ;
		bool m_process_error ;
		wxTimer *m_timer ;

		//(*Declarations(ProgressDialog)
		wxStaticText* StaticTextOverall;
		wxButton* Button1;
		wxGauge* GaugeCurrent;
		wxStaticText* StaticTextCurrent;
		wxGauge* GaugeOverall;
		//*)

	protected:

        void OnTimer(wxTimerEvent& evt);
        void OnCurrentProgressEvent( wxCommandEvent &event );
        void OnOverallProgressEvent( wxCommandEvent &event );
        void OnFinishedEvent( wxCommandEvent &event );
        void OnDialogEvent( wxCommandEvent &event );
		//(*Identifiers(ProgressDialog)
		static const long ID_GAUGE1;
		static const long ID_STATICTEXT2;
		static const long ID_GAUGE2;
		static const long ID_STATICTEXT3;
		static const long ID_BUTTON1;
		//*)

	private:

		//(*Handlers(ProgressDialog)
		void OnButton1Click(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
