// ArkToolGuiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ArkToolGui.h"
#include "ArkToolGuiDlg.h"
#include "FolderDialog.h"
#include "NewArkDialog.h"
#include "NewStringDialog.h"
#include "ArkHdrPair.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static UINT BASED_CODE status_indicators[] =
{
    IDS_INDICATOR_MSG,
};


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CArkToolGuiDlg dialog




CArkToolGuiDlg::CArkToolGuiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArkToolGuiDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArkToolGuiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE_ARKFILES, mTreeArkFiles);
}

BEGIN_MESSAGE_MAP(CArkToolGuiDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_CONTEXTMENU()
	ON_NOTIFY(NM_RCLICK, IDC_TREE_ARKFILES, &CArkToolGuiDlg::OnNMRclickTreeArkfiles)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_ARKFILES, &CArkToolGuiDlg::OnTvnSelchangedTreeArkfiles)
	ON_NOTIFY(TVN_KEYDOWN, IDC_TREE_ARKFILES, &CArkToolGuiDlg::OnTvnKeydownTreeArkfiles)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_TREE_ARKFILES, &CArkToolGuiDlg::OnTvnBeginlabeleditTreeArkfiles)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_TREE_ARKFILES, &CArkToolGuiDlg::OnTvnEndlabeleditTreeArkfiles)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILEMNU_NEW, &CArkToolGuiDlg::OnFileNew)
	ON_COMMAND(ID_FILEMNU_OPEN, &CArkToolGuiDlg::OnFileOpen)
	ON_COMMAND(ID_FILEMNU_SAVE, &CArkToolGuiDlg::OnFileSave)
	ON_COMMAND(ID_FILEMNU_SAVEAS, &CArkToolGuiDlg::OnFileSaveas)
	ON_COMMAND(ID_FILEMNU_CLOSE, &CArkToolGuiDlg::OnFileClose)
	ON_COMMAND(ID_FILEMNU_EXIT, &CArkToolGuiDlg::OnFileExit)
	ON_COMMAND(ID_OPTIONS_PERFORMCRYPTS, &CArkToolGuiDlg::OnOptionsPerformcrypts)
	ON_COMMAND(ID_OPTIONS_CONFIRMFILEOPERATIONS, &CArkToolGuiDlg::OnOptionsConfirmfileoperations)
	ON_COMMAND(ID_OPTIONS_FINDFILES, &CArkToolGuiDlg::OnOptionsFindfiles)
	ON_COMMAND(ID_OPTIONS_FINDNEXT, &CArkToolGuiDlg::OnOptionsFindnext)
	ON_COMMAND(ID_POPUP_EXTRACT, &CArkToolGuiDlg::OnPopupExtract)
	ON_COMMAND(ID_POPUP_ADDNEWDIR, &CArkToolGuiDlg::OnPopupAddnewdir)
	ON_COMMAND(ID_POPUP_INSERT, &CArkToolGuiDlg::OnPopupInsert)
	ON_COMMAND(ID_POPUP_REPLACE, &CArkToolGuiDlg::OnPopupReplace)
	ON_COMMAND(ID_POPUP_RENAME, &CArkToolGuiDlg::OnPopupRename)
	ON_COMMAND(ID_POPUP_DELETE, &CArkToolGuiDlg::OnPopupDelete)
END_MESSAGE_MAP()


// CArkToolGuiDlg message handlers

BOOL CArkToolGuiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_CurrentFileDir = "";
	m_CurrentArkDir = "C:\\";
	m_ConfirmFileChanges = true;
	m_PerformCrypts = true;
	m_SearchFilename = "**";
	m_SearchReachedEnd = false;
	
	// init image list
	mTreeArkFiles.SetImageList( m_ImgList.GetImageList(), TVSIL_NORMAL );
	
	// add status bar
	m_StatusBar.Create(this);
	m_StatusBar.SetIndicators(status_indicators, 1);
	CRect rect;
	GetClientRect(&rect);
	// size the two panes
	m_StatusBar.SetPaneInfo(0, IDS_INDICATOR_MSG, SBPS_STRETCH, 0);
	// this is where we actually draw it on the screen
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST,
		IDS_INDICATOR_MSG);
	
	Close();
	
// ONLY USED WHILE DEBUGGING
//m_CurrentArkDir = "D:\\gh2_hacks\\ark\\ps2_gh2";
//Open();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CArkToolGuiDlg::PreTranslateMessage(MSG* pMsg)
{
	// If edit control is visible in tree view control, when you send a
	// WM_KEYDOWN message to the edit control it will dismiss the edit
	// control. When the ENTER key was sent to the edit control, the
	// parent window of the tree view control is responsible for updating
	// the item's label in TVN_ENDLABELEDIT notification code.
	if ((pMsg->message == WM_KEYDOWN) &&
		(pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE))
	{
		CEdit* edit = mTreeArkFiles.GetEditControl();
		if(edit)
		{
			edit->SendMessage(WM_KEYDOWN, pMsg->wParam, pMsg->lParam);
			return TRUE;
		}
		// dont let the dialog handle return/escape keys
		// as that will cancel it. so tell it they've already been handled
		return TRUE;
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}


void CArkToolGuiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArkToolGuiDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArkToolGuiDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CArkToolGuiDlg::OnClose() 
{
	if( OkToContinue() )
		CDialog::OnClose();
}


void CArkToolGuiDlg::OnTvnKeydownTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVKEYDOWN pTVKeyDown = reinterpret_cast<LPNMTVKEYDOWN>(pNMHDR);
	
	// TODO: Add your control notification handler code here
	bool bCtrl = (::GetKeyState(VK_CONTROL) & 0x8000) != 0;
	bool bShift = (::GetKeyState(VK_SHIFT) & 0x8000) != 0;
	HTREEITEM hCur = mTreeArkFiles.GetSelectedItem();
	*pResult = 1;
	
	switch( pTVKeyDown->wVKey )
	{
	case 'N':
		if(bCtrl) { New(); return; }
		break;
	case 'O':
		if(bCtrl) { Open(); return; }
		break;
	case 'S':
		if(bCtrl) { Save(); return; }
		break;
	case 'A':
		if(bCtrl) { SaveAs(); return; }
		break;
	case 'C':
		if(bCtrl) { Close(); return; }
		break;
	case 'X':
		if(bCtrl) { Exit(); return; }
		break;
	
	case 'F':
		if(bCtrl) { OnOptionsFindfiles(); return; }
		break;
	case VK_F3:
		if(!bCtrl) { OnOptionsFindnext(); return; }
		break;
	
	case 'E':
		if(bCtrl) { Extract(hCur); return; }
		break;
	case 'D':
		if(bCtrl) { AddNewDir(hCur); return; }
		break;
	case VK_INSERT:
		Insert(hCur); return;
		break;
	case 'R':
		if(bCtrl) { Replace(hCur); return; }
		break;
	case VK_F2:
		RenameStart(hCur); return;
		break;
	case VK_DELETE:
		Delete(hCur); return;
		break;
	}
	
	*pResult = 0;
}


void CArkToolGuiDlg::OnTvnSelchangedTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	
	// my code
	HTREEITEM ht_item = mTreeArkFiles.GetSelectedItem();
	if( ht_item != NULL )
	{
		if( IsDirItem(ht_item) )
		{
			CString treename = TreeItemToTreename(ht_item);
			CString msg;
			int num_children = 0;
			HTREEITEM loc = mTreeArkFiles.GetChildItem(ht_item);
			while( loc != NULL )
			{
				num_children++;
				loc = mTreeArkFiles.GetNextItem(loc, TVGN_NEXT);
			}
			msg.Format("%s  :  %d Entries", treename, num_children);
			m_StatusBar.SetPaneText(0, msg);
		}
		else
		{
			CString treename = TreeItemToTreename(ht_item);
			CString arkname = TreeItemToArkname(ht_item);
			FileEntrySetIter iter;
			const FileEntry* p_entry = m_ArkHdr.First(iter, arkname);
			CString msg = treename;
			s64 filesize = p_entry->Filesize();
			if(filesize >= 1024*1024*1024)
				msg.AppendFormat("  :  %.1f GBytes", ((double)filesize)/(1024*1024*1024));
			else if(filesize >= 1024*1024)
				msg.AppendFormat("  :  %.1f MBytes", ((double)filesize)/(1024*1024));
			else if(filesize >= 1024)
				msg.AppendFormat("  :  %.1f KBytes", ((double)filesize)/1024);
			else
				msg.AppendFormat("  :  %ld Bytes", filesize);
			m_StatusBar.SetPaneText(0, msg);
		}
	}
	
	// not handled, so let default handler handle this message
	*pResult = 0;
}

void CArkToolGuiDlg::OnNMRclickTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	// Send WM_CONTEXTMENU to self
	SendMessage(WM_CONTEXTMENU, (WPARAM) m_hWnd, GetMessagePos());
	// Mark message as handled and suppress default handling
	*pResult = 1;
}

void CArkToolGuiDlg::OnTvnBeginlabeleditTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);
	
	// TODO: Add your control notification handler code here
	if(pTVDispInfo->item.hItem == mTreeArkFiles.GetRootItem())
	{
		*pResult = 1;
		return;
	}
	m_OldLabelName = TreeItemToArkname(pTVDispInfo->item.hItem);
	
	*pResult = 0;
}

void CArkToolGuiDlg::OnTvnEndlabeleditTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);
	
	// TODO: Add your control notification handler code here
	TVITEM& item = pTVDispInfo->item;
	*pResult = 1;
	
	if(item.pszText)
	{
		// check if new-name is valid
		CString new_name = item.pszText;
		new_name.MakeLower();
		if( !IsStringValid(new_name) )
		{
			// new-name is invalid
			MessageBox(_T("Name contains invalid characters!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
			*pResult = 0;
			return;
		}
		
		item.pszText = new_name.GetBuffer();
		mTreeArkFiles.SetItem(&item);
		m_NewLabelName = TreeItemToArkname(item.hItem);
		RenameEnd(m_NewLabelName, m_OldLabelName);
		mTreeArkFiles.SelectItem(mTreeArkFiles.GetRootItem());
		mTreeArkFiles.SelectItem(item.hItem);
		*pResult = 0;
	}
}

void CArkToolGuiDlg::OnContextMenu(CWnd* pWnd, CPoint ptMousePos) 
{
	// if Shift-F10
	if (ptMousePos.x == -1 && ptMousePos.y == -1)
		ptMousePos = (CPoint) GetMessagePos();
	
	mTreeArkFiles.ScreenToClient(&ptMousePos);
	
	UINT uFlags;
	HTREEITEM htItem = mTreeArkFiles.HitTest( ptMousePos, &uFlags );
	if( htItem == NULL )
		return;
	
	m_ActiveItem = htItem;
	CMenu menu;
	menu.LoadMenu(IDR_MNU_CONTEXT);
	CMenu* pPopup = menu.GetSubMenu(0);
	if( IsDirItem(htItem) )
	{
		pPopup->ModifyMenu(ID_POPUP_EXTRACT, MF_BYCOMMAND|MF_STRING, ID_POPUP_EXTRACT, "&Extract Dir\tCtrl+E");
		pPopup->ModifyMenu(ID_POPUP_RENAME, MF_BYCOMMAND|MF_STRING, ID_POPUP_RENAME, "Re&name Dir\tF2");
		pPopup->ModifyMenu(ID_POPUP_DELETE, MF_BYCOMMAND|MF_STRING, ID_POPUP_DELETE, "&Delete Dir\tDelete");
		pPopup->EnableMenuItem(ID_POPUP_REPLACE, MF_BYCOMMAND|MF_GRAYED);
		pPopup->EnableMenuItem(ID_POPUP_RENAME, MF_BYCOMMAND|((htItem == mTreeArkFiles.GetRootItem()))?MF_GRAYED:MF_ENABLED);
	}
	else
	{
		pPopup->ModifyMenu(ID_POPUP_EXTRACT, MF_BYCOMMAND|MF_STRING, ID_POPUP_EXTRACT, "&Extract File\tCtrl+E");
		pPopup->ModifyMenu(ID_POPUP_RENAME, MF_BYCOMMAND|MF_STRING, ID_POPUP_RENAME, "Re&name File\tF2");
		pPopup->ModifyMenu(ID_POPUP_DELETE, MF_BYCOMMAND|MF_STRING, ID_POPUP_DELETE, "&Delete File\tDelete");
		pPopup->EnableMenuItem(ID_POPUP_REPLACE, MF_BYCOMMAND|MF_ENABLED);
		pPopup->EnableMenuItem(ID_POPUP_RENAME, MF_BYCOMMAND|MF_ENABLED);
	}
	mTreeArkFiles.ClientToScreen(&ptMousePos);
	pPopup->TrackPopupMenu( TPM_LEFTALIGN, ptMousePos.x, ptMousePos.y, this );
}



CString CArkToolGuiDlg::TreeItemToTreename(HTREEITEM item)
{
	CString filename = "";
	CString temp = "";
	HTREEITEM root = mTreeArkFiles.GetRootItem();
	HTREEITEM loc = item;
	if(loc == root)
		filename = "Ark File Contents";
	while( loc != root )
	{
		temp = filename;
		filename = mTreeArkFiles.GetItemText(loc);
		if( temp.GetLength() != 0)
		{
			filename += "/";
			filename += temp;
		}
		
		loc = mTreeArkFiles.GetParentItem(loc);
	}
	return filename;
}
CString CArkToolGuiDlg::TreeItemToArkname(HTREEITEM item)
{
	CString filename = "";
	CString temp = "";
	HTREEITEM root = mTreeArkFiles.GetRootItem();
	HTREEITEM loc = item;
	while( loc != root )
	{
		temp = filename;
		filename = mTreeArkFiles.GetItemText(loc);
		if( temp.GetLength() != 0)
		{
			filename += "/";
			filename += temp;
		}
		
		loc = mTreeArkFiles.GetParentItem(loc);
	}
	
	if(filename.Left(6) == "system")
		filename.Insert(0, "../../");
	
	FileEntrySetIter iter;
	if( IsDirItem(item) )
	{
		if( filename == "")
			filename = "*";
		else
			filename += "/*";
	}
	return filename;
}

HTREEITEM CArkToolGuiDlg::FilenameToTreeItem(const CString& testFilename)
{
	CString filename = testFilename;
	if(filename.Left(6) == "../../")
		filename = filename.Right(filename.GetLength()-6);
	
	HTREEITEM loc = mTreeArkFiles.GetRootItem();
	
	int start_idx = 0;
	int end_idx = 0;
	CString entry;
	while( end_idx >= 0 )
	{
		HTREEITEM test_loc;

		// get the entry string to search for
		end_idx = filename.Find('/', start_idx);
		if(end_idx >= 0)
		{
			// searching for dir
			entry = filename.Mid(start_idx, end_idx-start_idx);
			test_loc = mTreeArkFiles.GetChildItem(loc);
		}
		else
		{
			// searching for file
			entry = filename.Mid(start_idx);
			test_loc = mTreeArkFiles.GetChildItem(loc);
		}
		
		// search thru entries
		while( test_loc != NULL )
		{
			CString text = mTreeArkFiles.GetItemText(test_loc);
			if(text == entry)
			{
				// entry was found
				loc = test_loc;
				break;
			}
			
			test_loc = mTreeArkFiles.GetNextItem(test_loc, TVGN_NEXT);
		}
		// check if item was found
		if( test_loc == NULL )
			return NULL;
		
		// prepare to get the next string
		start_idx = end_idx+1;
	}
	
	// return found item
	return loc;
}

HTREEITEM CArkToolGuiDlg::DirnameToTreeItem(const CString& dirname)
{
	return FilenameToTreeItem(dirname);
}


bool CArkToolGuiDlg::IsDirItem(HTREEITEM hItem)
{
	TVITEM tv_item;
	tv_item.mask = TVIF_PARAM;
	tv_item.hItem = hItem;
	mTreeArkFiles.GetItem(&tv_item);
	return tv_item.lParam == 1;
}


bool CArkToolGuiDlg::AddFileToTree(const CString& filepath, HTREEITEM* newItem)
{
	// split path into base dirname and filename
	// then ensure the base dir exists
	int slash_idx = filepath.ReverseFind('/');
	CString filename;
	CString base_dirname;
	HTREEITEM dir_item;
	if(slash_idx >= 0)
	{
		// has base dir
		filename = filepath.Right(filepath.GetLength()-slash_idx-1);
		base_dirname = filepath.Left(slash_idx);
		if( !AddDirToTree(base_dirname, &dir_item) )
			return false;
	}
	else
	{
		// no base dir
		filename = filepath;
		base_dirname = "";
		dir_item = mTreeArkFiles.GetRootItem();
	}
	
	// now add the file to the tree
	TVINSERTSTRUCT insert;
	insert.hParent = dir_item;
	insert.hInsertAfter = TVI_SORT;
	insert.item.mask = TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM;
	insert.item.pszText = filename.GetBuffer();
	insert.item.iImage = m_ImgList.GetFileIcon(filename);
	insert.item.iSelectedImage = m_ImgList.GetFileIcon(filename, TRUE);
	insert.item.lParam = 0;		// 0 for files, 1 for dirs
	HTREEITEM new_loc = mTreeArkFiles.InsertItem(&insert);
	
	if(newItem)
		*newItem = new_loc;
	return true;
}

bool CArkToolGuiDlg::RemoveFileFromTree(const CString& filepath)
{
	HTREEITEM item = FilenameToTreeItem(filepath);
	if(item != NULL)
	{
		mTreeArkFiles.DeleteItem(item);
		return true;
	}
	else
	{
		return false;
	}
}

bool CArkToolGuiDlg::AddDirToTree(const CString& dirpath, HTREEITEM* newItem)
{
	// use a structure for insertion for better insertion speed
	// (since only the string is changing each time)
	TVINSERTSTRUCT insert;
	insert.hParent = NULL;
	insert.hInsertAfter = TVI_SORT;
	insert.item.mask = TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM;
	insert.item.lParam = 1;		// 0 for files, 1 for dirs
	
	// skip the "../../" on system files
	CString insert_path = dirpath;
	while( insert_path.Left(6) == "../../" )
		insert_path = insert_path.Right(insert_path.GetLength()-6);
	
	// navigate to the required dirpath, inserted any missing dirs as needed
	HTREEITEM search_loc = mTreeArkFiles.GetRootItem();
	HTREEITEM parent_loc = search_loc;
	int slash_idx;
	while( insert_path.GetLength() > 0)
	{
		slash_idx = insert_path.Find('/');
		if(slash_idx < 0)
			slash_idx = insert_path.GetLength();
		CString curr_dir = insert_path.Left(slash_idx);
		
		// check if dirname exsits
		search_loc = mTreeArkFiles.GetNextItem(parent_loc, TVGN_CHILD);
		while( search_loc )
		{
			if( curr_dir == mTreeArkFiles.GetItemText(search_loc) )
			{
				// dirname already exists
				parent_loc = search_loc;
				break;
			}
			search_loc = mTreeArkFiles.GetNextItem(search_loc, TVGN_NEXT);
		}
		
		// insert dirname if it wasnt found
		if(search_loc == NULL)
		{
			insert.item.pszText = curr_dir.GetBuffer();
			insert.item.iImage = m_ImgList.GetDirIcon(curr_dir);
			insert.item.iSelectedImage = m_ImgList.GetDirIcon(curr_dir, TRUE);
			insert.hParent = parent_loc;
			parent_loc = mTreeArkFiles.InsertItem(&insert);
		}
		
		// prepare to insert the next dir
		insert_path = insert_path.Right(insert_path.GetLength()-slash_idx-1);
	}
	
	if(newItem)
		*newItem = parent_loc;
	return true;
}

bool CArkToolGuiDlg::RemoveDirFromTree(const CString& dirpath)
{
	HTREEITEM item = FilenameToTreeItem(dirpath);
	if(item != NULL)
	{
		mTreeArkFiles.DeleteItem(item);
		return true;
	}
	else
	{
		return false;
	}
}

bool CArkToolGuiDlg::AddRootToTree()
{
	CString rootname = _T("Ark File Contents");
	TVINSERTSTRUCT insert;
	insert.hParent = NULL;
	insert.hInsertAfter = TVI_SORT;
	insert.item.mask = TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM;
	insert.item.lParam = 1;		// 0 for files, 1 for dirs
	insert.item.pszText = rootname.GetBuffer();
	insert.item.iImage = m_ImgList.GetDirIcon(rootname);
	insert.item.iSelectedImage = m_ImgList.GetDirIcon(rootname, TRUE);
	mTreeArkFiles.InsertItem(&insert);
	return true;
}



void CArkToolGuiDlg::OnFileNew()	{ New(); }
void CArkToolGuiDlg::OnFileOpen()	{ Open(); }
void CArkToolGuiDlg::OnFileSave()	{ Save(); }
void CArkToolGuiDlg::OnFileSaveas()	{ SaveAs(); }
void CArkToolGuiDlg::OnFileClose()	{ Close(); }
void CArkToolGuiDlg::OnFileExit()	{ Exit(); }


void CArkToolGuiDlg::OnOptionsPerformcrypts()
{
	m_PerformCrypts = !m_PerformCrypts;
	CMenu* p_menu = GetMenu();
	p_menu->CheckMenuItem(ID_OPTIONS_PERFORMCRYPTS, (m_PerformCrypts)?MF_CHECKED:MF_UNCHECKED);
}

void CArkToolGuiDlg::OnOptionsConfirmfileoperations()
{
	m_ConfirmFileChanges = !m_ConfirmFileChanges;
	CMenu* p_menu = GetMenu();
	p_menu->CheckMenuItem(ID_OPTIONS_CONFIRMFILEOPERATIONS, (m_ConfirmFileChanges)?MF_CHECKED:MF_UNCHECKED);
}

void CArkToolGuiDlg::OnOptionsFindfiles()
{
	CNewStringDialog filename_dlg("Enter Filename", "Enter filename to search for", m_SearchFilename.Mid(1, m_SearchFilename.GetLength()-2), this);
	if( filename_dlg.DoModal() != IDOK )
		return;
	m_SearchFilename = "*";
	m_SearchFilename += filename_dlg.m_strString;
	m_SearchFilename += "*";
	
	const FileEntry* p_entry;
	HTREEITEM item;
	if( (p_entry=m_ArkHdr.First(m_SearchIter, m_SearchFilename)) == NULL ||
		(item=FilenameToTreeItem(p_entry->Arkname())) == NULL )
	{
		// file not found
		MessageBox("Could not file file!", "Error", IDOK|MB_ICONEXCLAMATION);
		m_SearchReachedEnd = true;
	}
	else
	{
		// file found
		mTreeArkFiles.SelectItem(item);
		m_SearchReachedEnd = false;
	}
}

void CArkToolGuiDlg::OnOptionsFindnext()
{
	const FileEntry* p_entry;
	HTREEITEM item;
	p_entry = (m_SearchReachedEnd)
				? m_ArkHdr.First(m_SearchIter, m_SearchFilename)
				: m_ArkHdr.Next(m_SearchIter, m_SearchFilename);
	if( (p_entry == NULL) ||
		(item=FilenameToTreeItem(p_entry->Arkname())) == NULL )
	{
		// file not found
		MessageBox("Could not file file!", "Error", IDOK|MB_ICONEXCLAMATION);
		m_SearchReachedEnd = true;
	}
	else
	{
		// file found
		mTreeArkFiles.SelectItem(item);
		m_SearchReachedEnd = false;
	}
}



void CArkToolGuiDlg::OnPopupExtract()
{
	Extract(m_ActiveItem);
}

void CArkToolGuiDlg::OnPopupAddnewdir()
{
	AddNewDir(m_ActiveItem);
}

void CArkToolGuiDlg::OnPopupInsert()
{
	Insert(m_ActiveItem);
}

void CArkToolGuiDlg::OnPopupReplace()
{
	Replace(m_ActiveItem);
}

void CArkToolGuiDlg::OnPopupRename()
{
	RenameStart(m_ActiveItem);
}

void CArkToolGuiDlg::OnPopupDelete()
{
	Delete(m_ActiveItem);
}





void CArkToolGuiDlg::New()
{
	if( !OkToContinue() )
		return;
	
	// get details for new ark 
	CNewArkDialog newark_dlg;
	if( newark_dlg.DoModal() != IDOK )
		return;
	
	// get location of new ark
	CFolderDialog folder_dlg(m_CurrentArkDir, BIF_USENEWUI, this);
	folder_dlg.m_bi.lpszTitle = "Select the dir to create the new Ark files in...";
	if( folder_dlg.DoModal() != IDOK )
		return;
	
	s64 max_ark_size = newark_dlg.m_ArkMaxSize;
	int ark_version = newark_dlg.m_ArkVersion;
	bool is_new_style = newark_dlg.m_idxArkStyle == 0;
	Close();
	if( !m_ArkHdr.New(folder_dlg.GetPathName(), max_ark_size, is_new_style, ark_version) )
	{
		// error creating new
		MessageBox("Error creating Ark file!", "Error", IDOK|MB_ICONEXCLAMATION);
		return;
	}
	
	CString msg;
	m_CurrentArkDir = folder_dlg.GetPathName();
	msg.Format("Created Ark File \"%s\"", m_CurrentArkDir);
	m_StatusBar.SetPaneText(0, msg);
	
	// add root
	AddRootToTree();
}

void CArkToolGuiDlg::Open()
{
	if( !OkToContinue() )
		return;
	
	CFolderDialog folder_dlg(m_CurrentArkDir, BIF_USENEWUI, this);
	folder_dlg.m_bi.lpszTitle = "Select the dir containing Ark files...";
	if( folder_dlg.DoModal() != IDOK )
		return;

	CWaitCursor wait;
	Close();
	if( !m_ArkHdr.Open(folder_dlg.GetPathName()) )
	{
		// error opening
		MessageBox("Error opening Ark file!", "Error", IDOK|MB_ICONEXCLAMATION);
		wait.Restore();
		return;
	}
	CString msg;
	m_CurrentArkDir = folder_dlg.GetPathName();
	msg.Format("Please wait while opening Ark File \"%s\"...", m_CurrentArkDir);
	m_StatusBar.SetPaneText(0, msg);
	
	AddRootToTree();
	
	FileEntrySetIter iter;
	for(const FileEntry* p_entry=m_ArkHdr.First(iter);
		p_entry != NULL;
		p_entry=m_ArkHdr.Next(iter))
	{
		AddFileToTree( p_entry->Arkname() );
	}
	
	// expand the root item
	mTreeArkFiles.Expand(mTreeArkFiles.GetRootItem(), TVE_EXPAND);
	
	msg.Format("Opened Ark File \"%s\"", m_CurrentArkDir);
	m_StatusBar.SetPaneText(0, msg);
	wait.Restore();
}

void CArkToolGuiDlg::Save()
{
	CWaitCursor wait;
	m_StatusBar.SetPaneText(0, _T("Please wait while saving Ark File..."));
	if( !m_ArkHdr.Save() )
	{
		// error saving
		MessageBox("Error saving Ark file!", "Error", IDOK|MB_ICONEXCLAMATION);
		m_StatusBar.SetPaneText(0, _T("Error saving Ark file!"));
		wait.Restore();
		return;
	}
	
	m_StatusBar.SetPaneText(0, _T("Saved Ark File"));
	wait.Restore();
}

void CArkToolGuiDlg::SaveAs()
{
	CFolderDialog folder_dlg(m_CurrentArkDir, BIF_USENEWUI, this);
	folder_dlg.m_bi.lpszTitle = "Select the dir to save Ark files to...";
	if( folder_dlg.DoModal() != IDOK )
		return;
	
	CWaitCursor wait;
	CString msg;
	msg.Format("Please wait while saving Ark File to \"%s\"...", folder_dlg.GetPathName());
	m_StatusBar.SetPaneText(0, msg);
	
	if( !m_ArkHdr.SaveAs(folder_dlg.GetPathName(), true) )
	{
		// error saving
		MessageBox("Error saving Ark file!", "Error", IDOK|MB_ICONEXCLAMATION);
		m_StatusBar.SetPaneText(0, _T("Error saving Ark file!"));
		wait.Restore();
		return;
	}
	
	m_CurrentArkDir = folder_dlg.GetPathName();
	msg.Format("Saved Ark File As \"%s\"", m_CurrentArkDir);
	m_StatusBar.SetPaneText(0, msg);
	wait.Restore();
}

void CArkToolGuiDlg::Close()
{
	if( !OkToContinue() )
		return;
	
	m_ArkHdr.Close();
	
	// delete all entries and insert an empty root
	mTreeArkFiles.DeleteAllItems();
	
	CString msg;
	m_StatusBar.SetPaneText(0, _T("No Ark File Opened"));
}

void CArkToolGuiDlg::Exit()
{
	if( !OkToContinue() )
		return;
	
	Close();
	EndDialog(IDOK);
}

// returns:	true if this should exit
bool CArkToolGuiDlg::OkToContinue()
{
	if( m_ArkHdr.HasChanged() )
	{
		// user may want to save
		int button = MessageBox(
			_T("The current ark file has unsaved changes.\n"
			  "Do you wish to continue without saving changes?"),
			_T("Continue without saving?"), MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2);
		if(button == IDNO)
		{
			// user wants to save
			return false;
		}
	}
	
	// ok to exit
	return true;
}




// context menu functions
void CArkToolGuiDlg::Extract(HTREEITEM item)
{
	CWaitCursor wait;
	CString msg;
	msg.Format("Please wait while extracting entries...");
	m_StatusBar.SetPaneText(0, msg);
	
	if( IsDirItem(item) )
	{
		CFolderDialog folder_dlg(m_CurrentFileDir, BIF_USENEWUI, this);
		folder_dlg.m_bi.lpszTitle = "Select the dir to extract files to...";
		if( folder_dlg.DoModal() != IDOK )
		{
			msg.Format("Cancelled extracting entries");
			m_StatusBar.SetPaneText(0, msg);
			wait.Restore();
			return;
		}
		m_CurrentFileDir = folder_dlg.GetPathName();
		CString extract_base_dir = folder_dlg.GetPathName();
		extract_base_dir += "\\";
		extract_base_dir += mTreeArkFiles.GetItemText(item);
		extract_base_dir += "\\";
		CString ark_dirname = TreeItemToArkname(item);
		
		// extract files from ark/hdr
		FileEntrySetIter iter;
		for(const FileEntry* p_entry=m_ArkHdr.First(iter, ark_dirname);
			p_entry!=NULL;
			p_entry=m_ArkHdr.Next(iter, ark_dirname))
		{
			CString ark_filename = p_entry->Arkname();
			CString extract_filename = extract_base_dir;
			extract_filename += ark_filename.Right(ark_filename.GetLength()-ark_dirname.GetLength()+1);
			int idx;
			while( (idx=extract_filename.Find('/')) >= 0 )
			{
				extract_filename.SetAt(idx, '\\');
			}
			
			if( !m_ArkHdr.GetFile(extract_filename, ark_filename, m_PerformCrypts) )
			{
				CString msg;
				msg.Format("An error occurred extracting \"%s\"", ark_filename);
				MessageBox(msg, _T("Extract Error"), MB_OK|MB_ICONEXCLAMATION);
				m_StatusBar.SetPaneText(0, msg);
				wait.Restore();
				return;
			}
		}
	}
	else
	{
		CString ark_filename = TreeItemToArkname(item);
		int str_idx = ark_filename.ReverseFind('/');
		if(str_idx >= 0)
			str_idx++;
		else
			str_idx = 0;
		
		CFileDialog file_dlg(false, NULL, ark_filename.Right(ark_filename.GetLength()-str_idx));
		if( file_dlg.DoModal() != IDOK )
		{
			msg.Format("Cancelled extracting entries");
			m_StatusBar.SetPaneText(0, msg);
			wait.Restore();
			return;
		}
		
		m_CurrentFileDir = file_dlg.GetPathName();
		m_CurrentFileDir = m_CurrentFileDir.Left( max(m_CurrentFileDir.ReverseFind('\\'), 0) );
		
		if( !m_ArkHdr.GetFile(file_dlg.GetPathName(), ark_filename, m_PerformCrypts) )
		{
			CString msg;
			msg.Format("An error occurred extracting \"%s\"", TreeItemToTreename(item));
			MessageBox(msg, _T("Extract Error"), MB_OK|MB_ICONEXCLAMATION);
			m_StatusBar.SetPaneText(0, msg);
			wait.Restore();
			return;
		}
	}
	
	msg.Format("Finished extracting entries");
	m_StatusBar.SetPaneText(0, msg);
	wait.Restore();
}

void CArkToolGuiDlg::AddNewDir(HTREEITEM item)
{
	// get the base dir to add the new dir to
	HTREEITEM base_dir_item = item;
	if( !IsDirItem(base_dir_item) )
		base_dir_item = mTreeArkFiles.GetParentItem(base_dir_item);
	CString base_dirname = TreeItemToArkname(base_dir_item);
	int idx = base_dirname.ReverseFind('/');
	if(idx >= 0)
		base_dirname = base_dirname.Left(idx);
	else if(base_dirname == "*")
		base_dirname = "";
	
	// check if dir already exists with this name
	CNewStringDialog newdir_dlg("Enter Dirname", "Enter new dirname", "", this);
	CString new_dirname;
	bool dirname_is_ok = false;
	while( !dirname_is_ok )
	{
		// get name of new dir to add
		dirname_is_ok = true;
		if( newdir_dlg.DoModal() != IDOK )
			return;
		new_dirname = newdir_dlg.m_strString;
		
		// check if entry-name is valid
		new_dirname.MakeLower();
		if( !IsStringValid(new_dirname) )
		{
			// entry-name is invalid
			MessageBox(_T("Dirname is invalid!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
			dirname_is_ok = false;
			continue;
		}
		
		// check if entry-name already exists
		HTREEITEM test_loc = mTreeArkFiles.GetChildItem(base_dir_item);
		while( test_loc != NULL )
		{
			CString text = mTreeArkFiles.GetItemText(test_loc);
			if(text == new_dirname)
			{
				// dirname already exists
				MessageBox(_T("Entry-name already exists!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
				dirname_is_ok = false;
				break;
			}
			test_loc = mTreeArkFiles.GetNextItem(test_loc, TVGN_NEXT);
		}
	}
	
	// dirname doesnt exist, so add it
	CString dirpath = base_dirname;
	if(base_dirname == "")
		dirpath = new_dirname;
	else
		dirpath = base_dirname + '/' + new_dirname;
	HTREEITEM newdir_item;
	AddDirToTree(dirpath, &newdir_item);
	mTreeArkFiles.SelectItem(newdir_item);
}

void CArkToolGuiDlg::Insert(HTREEITEM item)
{
	// get file to insert
	CFileDialog file_dlg(true);
	if( file_dlg.DoModal() != IDOK )
		return;
	
	m_CurrentFileDir = file_dlg.GetPathName();
	m_CurrentFileDir = m_CurrentFileDir.Left( max(m_CurrentFileDir.ReverseFind('\\'), 0) );
	
	// get the base dir to insert the new file in
	HTREEITEM base_dir_item = item;
	if( !IsDirItem(base_dir_item) )
		base_dir_item = mTreeArkFiles.GetParentItem(base_dir_item);
	CString base_dirname = TreeItemToArkname(base_dir_item);
	int idx = base_dirname.ReverseFind('/');
	if(idx >= 0)
		base_dirname = base_dirname.Left(idx);
	else if(base_dirname == "*")
		base_dirname = "";
	
	// get insert filename and check if file already exists with this name
	CNewStringDialog newfile_dlg("Enter Filename", "Enter the filename to insert as", file_dlg.GetFileName(), this);
	CString new_filename;
	bool filename_is_ok = false;
	while( !filename_is_ok )
	{
		// get name of new file to insert as
		filename_is_ok = true;
		if( newfile_dlg.DoModal() != IDOK )
			return;
		new_filename = newfile_dlg.m_strString;
		
		// check if entry name is valid
		new_filename.MakeLower();
		if( !IsStringValid(new_filename) )
		{
			// invalid chars
			MessageBox(_T("Filename is invalid!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
			filename_is_ok = false;
			continue;
		}
		
		// check if entry-name already exists
		HTREEITEM test_loc = mTreeArkFiles.GetChildItem(base_dir_item);
		while( test_loc != NULL )
		{
			CString text = mTreeArkFiles.GetItemText(test_loc);
			if(text == new_filename)
			{
				// filename already exists
				MessageBox(_T("Entry-name already exists!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
				filename_is_ok = false;
				break;
			}
			test_loc = mTreeArkFiles.GetNextItem(test_loc, TVGN_NEXT);
		}
	}	
	
	// filename doesnt exist, so add it
	CString ark_filename;
	if(base_dirname == "")
		ark_filename = new_filename;
	else
		ark_filename = base_dirname + '/' + new_filename;
	if( !m_ArkHdr.AddFile(file_dlg.GetPathName(), ark_filename, m_PerformCrypts) )
	{
		CString msg;
		msg.Format("An error occurred inserting \"%s\"", ark_filename);
		MessageBox(msg, _T("Insert Error"), MB_OK|MB_ICONEXCLAMATION);
		return;
	}
	HTREEITEM newfile_item;
	AddFileToTree(ark_filename, &newfile_item);
	mTreeArkFiles.SelectItem(newfile_item);
}

void CArkToolGuiDlg::Replace(HTREEITEM item)
{
	// get file to insert
	CFileDialog file_dlg(true);
	if( file_dlg.DoModal() != IDOK )
		return;
	
	m_CurrentFileDir = file_dlg.GetPathName();
	m_CurrentFileDir = m_CurrentFileDir.Left( max(m_CurrentFileDir.ReverseFind('\\'), 0) );
	
	// split the arkname into basedir and filename
	CString arkname = TreeItemToArkname(item);
	CString base_dirname = arkname.Left( max(arkname.ReverseFind('/'), 0) );
	CString new_filename = arkname.Right( arkname.GetLength() - (max(arkname.ReverseFind('/'), 0)) );
	
	// add filename
	if( !m_ArkHdr.ReplaceAFile(file_dlg.GetPathName(), arkname, m_PerformCrypts) )
	{
		CString msg;
		msg.Format("An error occurred replacing \"%s\"", arkname);
		MessageBox(msg, _T("Replace Error"), MB_OK|MB_ICONEXCLAMATION);
		return;
	}
	mTreeArkFiles.SelectItem(mTreeArkFiles.GetRootItem());
	mTreeArkFiles.SelectItem(item);
}

void CArkToolGuiDlg::RenameStart(HTREEITEM item)
{
	// cant edit the root
	if(item == mTreeArkFiles.GetRootItem())
		return;
	
	// start editing
	// the end of editing needs to be checked to see whether the label changed
	mTreeArkFiles.EditLabel(item);
}

void CArkToolGuiDlg::RenameEnd(CString newArkFilename, CString oldArkFilename)
{
	// the tree string has been updated already,
	// just need to update the entries in the arkhdr
	CWaitCursor wait;
	FileEntrySetIter iter;
	bool is_dir = false;
	if(newArkFilename.Right(2) == "/*")
	{
		// is dir
		is_dir = true;
		newArkFilename = newArkFilename.Left(newArkFilename.GetLength()-2);
	}
	for(const FileEntry* p_entry=m_ArkHdr.First(iter, oldArkFilename);
		p_entry!=NULL;
		)
	{
		const FileEntry* p_old_entry = p_entry;
		p_entry = m_ArkHdr.Next(iter, oldArkFilename);
		
		CString old_name = p_old_entry->Arkname();
		CString new_name = newArkFilename;
		if(is_dir)
		{
			CString filename = p_old_entry->Arkname();
			new_name += filename.Right(filename.GetLength() - (oldArkFilename.GetLength()-2));
		}
		if( !m_ArkHdr.RenameFile(new_name, old_name) )
		{
			CString msg;
			msg.Format("An error occurred renaming \"%s\" to \"%s\'", old_name, new_name);
			MessageBox(msg, _T("Rename Error"), MB_OK|MB_ICONEXCLAMATION);
			m_StatusBar.SetPaneText(0, msg);
			wait.Restore();
			return;
		}
	}
	wait.Restore();
}

void CArkToolGuiDlg::Delete(HTREEITEM item)
{
 	CString treename = TreeItemToTreename(item);
	if(m_ConfirmFileChanges)
	{
		CString msg;
		msg.Format("Are you sure you want to delete \"%s\" ?", treename);
		if( IDYES != MessageBox(msg, _T("Warning"), MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2) )
			return;
	}
	
	CWaitCursor wait;
	CString msg;
	msg.Format("Please wait while deleting entries...");
	m_StatusBar.SetPaneText(0, msg);

	if( IsDirItem(item) )
	{
		// extract files from ark/hdr
		FileEntrySetIter iter;
		CString ark_dirname = TreeItemToArkname(item);
		for(const FileEntry* p_entry=m_ArkHdr.First(iter, ark_dirname);
			p_entry!=NULL;
			)
		{
			const FileEntry* p_old_entry = p_entry;
			p_entry = m_ArkHdr.Next(iter, ark_dirname);
			
			CString ark_filename = p_old_entry->Arkname();
			if( !m_ArkHdr.RemoveFile(ark_filename) )
			{
				CString msg;
				msg.Format("An error occurred deleting \"%s\"", ark_filename);
				MessageBox(msg, _T("Delete Error"), MB_OK|MB_ICONEXCLAMATION);
				m_StatusBar.SetPaneText(0, msg);
				wait.Restore();
				return;
			}
			RemoveFileFromTree(ark_filename);
		}
		// now remove the dir itself
		if(item == mTreeArkFiles.GetRootItem())
		{
			mTreeArkFiles.DeleteAllItems();
			AddRootToTree();
		}
		else
		{
			mTreeArkFiles.DeleteItem(item);
		}
	}
	else
	{
		CString ark_filename = TreeItemToArkname(item);
		if( !m_ArkHdr.RemoveFile(ark_filename) )
		{
			CString msg;
			msg.Format("An error occurred deleting \"%s\"", ark_filename);
			MessageBox(msg, _T("Delete Error"), MB_OK|MB_ICONEXCLAMATION);
			m_StatusBar.SetPaneText(0, msg);
			wait.Restore();
			return;
		}
		RemoveFileFromTree(ark_filename);
	}
	
	msg.Format("Finished deleting entries");
	m_StatusBar.SetPaneText(0, msg);
	wait.Restore();
}


// checks if string is valid to be used as a file or dirname
bool CArkToolGuiDlg::IsStringValid(CString str)
{
	// check that a string isnt all "." characters
	int offset = 0;
	str.Tokenize(".", offset);
	if(offset == -1)
		return false;
	
	// this checks against all "valid" characters
	offset = 0;
	str.Tokenize("abcdefghijklmnopqrstuvwxyz0123456789_-.", offset);
	return offset == -1;
}


