// ArkToolGuiDlg.h : header file
//

#include "ArkHdrPair.h"
#pragma once
#include "afxcmn.h"

#include "SystemImageList.h"


// CArkToolGuiDlg dialog
class CArkToolGuiDlg : public CDialog
{
// Construction
public:
	CArkToolGuiDlg(CWnd* pParent = NULL);	// standard constructor

private:
	// main menu functions
	void New();
	void Open();
	void Save();
	void SaveAs();
	void Close();
	void Exit();
	bool OkToContinue();
	// context menu functions
	void Extract(HTREEITEM item);
	void AddNewDir(HTREEITEM item);
	void Insert(HTREEITEM item);
	void RenameStart(HTREEITEM item);
	void RenameEnd(CString newArkFilename, CString oldArkFilename);
	void Replace(HTREEITEM item);
	void Delete(HTREEITEM item);
	
	bool IsStringValid(CString str);
	
	CString TreeItemToArkname(HTREEITEM item);
	CString TreeItemToTreename(HTREEITEM item);
	HTREEITEM FilenameToTreeItem(const CString& filename);
	HTREEITEM DirnameToTreeItem(const CString& dirname);
	
	bool IsDirItem(HTREEITEM hItem);
	bool AddFileToTree(const CString& filepath, HTREEITEM* newItem=NULL);
	bool RemoveFileFromTree(const CString& filepath);
	bool AddDirToTree(const CString& dirpath, HTREEITEM* newItem=NULL);
	bool RemoveDirFromTree(const CString& dirpath);
	bool AddRootToTree();
	
	ArkHdrPair m_ArkHdr;
	CString m_CurrentFileDir;
	CString m_CurrentArkDir;
	bool m_ConfirmFileChanges;
	bool m_PerformCrypts;
	CSystemImageList m_ImgList;
	CString m_SearchFilename;
	FileEntrySetIter m_SearchIter;
	bool m_SearchReachedEnd;
	CString m_OldLabelName;
	CString m_NewLabelName;

	
// Dialog Data
	enum { IDD = IDD_ARKTOOLGUI_DIALOG };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;
	HTREEITEM m_ActiveItem;
	CTreeCtrl mTreeArkFiles;
	CStatusBar m_StatusBar;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	virtual BOOL CArkToolGuiDlg::PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnClose();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTvnBeginlabeleditTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnEndlabeleditTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnKeydownTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnSelchangedTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickTreeArkfiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveas();
	afx_msg void OnFileClose();
	afx_msg void OnFileExit();
	afx_msg void OnOptionsPerformcrypts();
	afx_msg void OnOptionsConfirmfileoperations();
	afx_msg void OnOptionsFindfiles();
	afx_msg void OnOptionsFindnext();
	afx_msg void OnPopupExtract();
	afx_msg void OnPopupAddnewdir();
	afx_msg void OnPopupInsert();
	afx_msg void OnPopupReplace();
	afx_msg void OnPopupRename();
	afx_msg void OnPopupDelete();
	DECLARE_MESSAGE_MAP()
};
