// NewArkDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ArkToolGui.h"
#include "NewArkDialog.h"


// CNewArkDialog dialog

IMPLEMENT_DYNAMIC(CNewArkDialog, CDialog)

CNewArkDialog::CNewArkDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CNewArkDialog::IDD, pParent)
	, m_ArkVersion(0)
	, m_idxArkStyle(0)
	, m_ArkMaxSize(0)
{
}

CNewArkDialog::~CNewArkDialog()
{
}

void CNewArkDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
//	DDX_CBString(pDX, IDC_CMB_ARKTYPE, m_strArkType);
	DDX_Text(pDX, IDC_EDT_ARK_VERSION, m_ArkVersion);
	DDX_Radio(pDX, IDC_RAD_ARK_STYLE, m_idxArkStyle);
	DDX_Text(pDX, IDC_EDT_ARK_SIZE, m_ArkMaxSize);
	DDX_Control(pDX, IDC_CMB_ARKTYPE, m_cmbArkType);
}


BEGIN_MESSAGE_MAP(CNewArkDialog, CDialog)
	ON_EN_CHANGE(IDC_EDT_ARK_VERSION, &CNewArkDialog::OnEnChangeEdtArkVersion)
	ON_EN_CHANGE(IDC_EDT_ARK_SIZE, &CNewArkDialog::OnEnChangeEdtArkSize)
	ON_CBN_SELCHANGE(IDC_CMB_ARKTYPE, &CNewArkDialog::OnCbnSelchangeCmbArktype)
	ON_BN_CLICKED(IDC_RAD_ARK_STYLE, &CNewArkDialog::OnBnClickedRadArkStyle)
	ON_BN_CLICKED(IDC_RAD_OLD, &CNewArkDialog::OnBnClickedRadArkStyleOld)
END_MESSAGE_MAP()


BOOL CNewArkDialog::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	m_cmbArkType.AddString("Custom");
	m_cmbArkType.AddString("PS2 - GH1");
	m_cmbArkType.AddString("PS2 - GH2");
	m_cmbArkType.AddString("PS2 - GH80s");
	m_cmbArkType.AddString("PS2 - Rockband");
	m_cmbArkType.AddString("PS3 - Rockband");
	m_cmbArkType.AddString("Xbox - Karaoke Revolution");
	m_cmbArkType.AddString("Xbox360 - GH2");
	m_cmbArkType.AddString("Xbox360 - Rockband");
	
	m_cmbArkType.SetCurSel(0);
	UpdateData(true);
	SetValuesFromType();
	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


// CNewArkDialog message handlers

void CNewArkDialog::OnCbnSelchangeCmbArktype()
{
//	UpdateData(false);
	SetValuesFromType();
	UpdateData(false);
}

void CNewArkDialog::OnEnChangeEdtArkVersion()
{
	UpdateData(true);
}

void CNewArkDialog::OnBnClickedRadArkStyle()
{
	UpdateData(true);
}

void CNewArkDialog::OnBnClickedRadArkStyleOld()
{
	UpdateData(true);
}

void CNewArkDialog::OnEnChangeEdtArkSize()
{
	UpdateData(true);
}


void CNewArkDialog::SetValuesFromType()
{
	int cur = m_cmbArkType.GetCurSel();
	switch(cur)
	{
	// custom
	case 0:
		m_ArkVersion = 3;
		m_idxArkStyle = 0;
		m_ArkMaxSize = 0;
		break;
	// PS2 - GH1
	case 1:
		m_ArkVersion = 3;
		m_idxArkStyle = 1;
		m_ArkMaxSize = 0;
		break;
	// PS2 - GH2
	case 2:
		m_ArkVersion = 3;
		m_idxArkStyle = 1;
		m_ArkMaxSize = 0;
		break;
	// PS2 - GH80s
	case 3:
		m_ArkVersion = 3;
		m_idxArkStyle = 1;
		m_ArkMaxSize = 0;
		break;
	// PS2 - Rockband
	case 4:
		m_ArkVersion = 4;
		m_idxArkStyle = 0;
		m_ArkMaxSize = 2000000000;
		break;
	// PS3 - Rockband
	case 5:
		m_ArkVersion = 3;
		m_idxArkStyle = 0;
		m_ArkMaxSize = 2000000000;
		break;
	// Xbox - Karaoke Revolution
	case 6:
		m_ArkVersion = 3;
		m_idxArkStyle = 1;
		m_ArkMaxSize = 100000000;
		break;
	// Xbox360 - GH2
	case 7:
		m_ArkVersion = 3;
		m_idxArkStyle = 0;
		m_ArkMaxSize = 0;
		break;
	// Xbox360 - Rockband
	case 8:
		m_ArkVersion = 3;
		m_idxArkStyle = 0;
		m_ArkMaxSize = 2000000000;
		break;
	}
}

