/***************************************************************
 * Name:      gh2makerMain.cpp
 * Purpose:   Code for Application Frame
 * Author:     ()
 * Created:   2008-04-10
 * Copyright:  ()
 * License:
 **************************************************************/
#include <wx/wxprec.h>

#ifndef WX_PRECOMP
#	include <wx/wx.h>
#endif

#include "gh2makerMain.h"
#include <wx/msgdlg.h>
#include <wx/filename.h>
#include "CreateMidiDialog.h"
#include "CreateOggDialog.h"
#include "DTBOptionsDialog.h"
#include "MidiFile.h"
#include "OggFile.h"
#include "OggMerger.h"
#include "ProgressDialog.h"
#include "FinalizerThread.h"

#ifdef WIN32
#pragma comment (lib, "COMCTL32.LIB")
#pragma comment(lib, "Rpcrt4.lib")
#endif

#include "guitarhero.xpm"

wxIcon g_icon ;

#ifdef __cplusplus
extern "C" {
#endif

int midicomp_decompile( char *ifilename, char *ofilename );
#include "dtb/dtb.h"
#include "ini/inifile.h"

#ifdef __cplusplus
}
#endif

//(*InternalHeaders(gh2makerFrame)
#include <wx/settings.h>
#include <wx/intl.h>
#include <wx/string.h>
//*)

gh2makerFrame *g_frame ;
int g_num_converted_ogg =0;

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(gh2makerFrame)
const long gh2makerFrame::ID_GRID1 = wxNewId();
const long gh2makerFrame::ID_TEXTCTRL3 = wxNewId();
const long gh2makerFrame::ID_TEXTCTRL2 = wxNewId();
const long gh2makerFrame::ID_TEXTCTRL1 = wxNewId();
const long gh2makerFrame::ID_STATICTEXT3 = wxNewId();
const long gh2makerFrame::ID_STATICTEXT1 = wxNewId();
const long gh2makerFrame::ID_STATICTEXT2 = wxNewId();
const long gh2makerFrame::ID_BUTTON5 = wxNewId();
const long gh2makerFrame::ID_BUTTON3 = wxNewId();
const long gh2makerFrame::ID_BUTTON4 = wxNewId();
const long gh2makerFrame::ID_BUTTON1 = wxNewId();
const long gh2makerFrame::ID_BUTTON2 = wxNewId();
const long gh2makerFrame::ID_BUTTON6 = wxNewId();
const long gh2makerFrame::ID_BUTTON8 = wxNewId();
const long gh2makerFrame::ID_BUTTON7 = wxNewId();
const long gh2makerFrame::idMenuFileNew = wxNewId();
const long gh2makerFrame::idMenuOpenProject = wxNewId();
const long gh2makerFrame::idFileSaveProject = wxNewId();
const long gh2makerFrame::idFileSaveProjectAs = wxNewId();
const long gh2makerFrame::idMenuDTBSettings = wxNewId();
const long gh2makerFrame::idSelectARK = wxNewId();
const long gh2makerFrame::idCreateMIDI = wxNewId();
const long gh2makerFrame::idCreateOGG = wxNewId();
const long gh2makerFrame::idClearLine = wxNewId();
const long gh2makerFrame::idRevalidateOGGs = wxNewId();
const long gh2makerFrame::idMenuQuit = wxNewId();
const long gh2makerFrame::idMenuAbout = wxNewId();
const long gh2makerFrame::ID_STATUSBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(gh2makerFrame,wxFrame)
    //(*EventTable(gh2makerFrame)
    //*)
END_EVENT_TABLE()

gh2makerFrame::gh2makerFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(gh2makerFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(1000,700));
    Grid1 = new wxGrid(this, ID_GRID1, wxPoint(0,0), wxSize(1000,492), 0, _T("ID_GRID1"));
    Grid1->CreateGrid(74,4);
    TextMidiControl = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxPoint(40,540), wxSize(720,27), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    TextMidiControl->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_GRAYTEXT));
    TextArkControl = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxPoint(40,508), wxSize(720,27), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    TextArkControl->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_GRAYTEXT));
    TextOggControl = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxPoint(40,572), wxSize(720,27), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    TextOggControl->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_GRAYTEXT));
    StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("MIDI"), wxPoint(0,548), wxSize(34,16), wxALIGN_RIGHT, _T("ID_STATICTEXT3"));
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("ARK"), wxPoint(0,516), wxSize(34,16), wxALIGN_RIGHT, _T("ID_STATICTEXT1"));
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("OGG"), wxPoint(0,580), wxSize(34,16), wxALIGN_RIGHT, _T("ID_STATICTEXT2"));
    SelectMidiButton = new wxButton(this, ID_BUTTON5, _("Select"), wxPoint(768,540), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON5"));
    SelectArkButton = new wxButton(this, ID_BUTTON3, _("Select"), wxPoint(768,508), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON3"));
    CreateMidiButton = new wxButton(this, ID_BUTTON4, _("Create"), wxPoint(848,540), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON4"));
    CreateOggButton = new wxButton(this, ID_BUTTON1, _("Create"), wxPoint(848,572), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON1"));
    SelectOggButton = new wxButton(this, ID_BUTTON2, _("Select"), wxPoint(768,572), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON2"));
    ButtonFinalize = new wxButton(this, ID_BUTTON6, _("Make It!"), wxPoint(452,612), wxSize(96,32), 0, wxDefaultValidator, _T("ID_BUTTON6"));
    ButtonClearMidi = new wxButton(this, ID_BUTTON8, _("Clear"), wxPoint(928,540), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON8"));
    ButtonClearOgg = new wxButton(this, ID_BUTTON7, _("Clear"), wxPoint(928,572), wxSize(70,27), 0, wxDefaultValidator, _T("ID_BUTTON7"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuFileNewProject = new wxMenuItem(Menu1, idMenuFileNew, _("New Project\tCtrl-N"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuFileNewProject);
    MenuOpenProject = new wxMenuItem(Menu1, idMenuOpenProject, _("Open Project\tCtrl-O"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuOpenProject);
    MenuSaveProject = new wxMenuItem(Menu1, idFileSaveProject, _("Save Project\tCTRL-S"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuSaveProject);
    MenuSaveProjectAs = new wxMenuItem(Menu1, idFileSaveProjectAs, _("Save Project &As"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuSaveProjectAs);
    MenuDTBSettings = new wxMenuItem(Menu1, idMenuDTBSettings, _("Game Options\tCtrl-G"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuDTBSettings);
    MenuItem3 = new wxMenuItem(Menu1, idSelectARK, _("Select ARK\tCTRL-A"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem3);
    MenuItem4 = new wxMenuItem(Menu1, idCreateMIDI, _("Create MIDI\tALT-M"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem4);
    MenuItem5 = new wxMenuItem(Menu1, idCreateOGG, _("Create OGG\tALT-O"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem5);
    MenuItem6 = new wxMenuItem(Menu1, idClearLine, _("Clear Line\tCTRL-X"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem6);
    MenuItemRevalidate = new wxMenuItem(Menu1, idRevalidateOGGs, _("Revalidate OGGs"), _("Rescans your OGGs to see if they\'re valid."), wxITEM_NORMAL);
    Menu1->Append(MenuItemRevalidate);
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);

    Connect(ID_GRID1,wxEVT_GRID_SELECT_CELL,(wxObjectEventFunction)&gh2makerFrame::OnGrid1CellSelect);
    Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnSelectMidiButtonClick);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnSelectArkButtonClick);
    Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnCreateMidiButtonClick);
    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnCreateOggButtonClick);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnSelectOggButtonClick);
    Connect(ID_BUTTON6,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnButtonFinalizeClick);
    Connect(ID_BUTTON8,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnButtonClearMidiClick);
    Connect(ID_BUTTON7,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&gh2makerFrame::OnButtonClearOggClick);
    Connect(idMenuFileNew,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuFileNewProjectSelected);
    Connect(idMenuOpenProject,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuOpenProjectSelected);
    Connect(idFileSaveProject,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuSaveProjectSelected);
    Connect(idFileSaveProjectAs,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuSaveProjectAsSelected);
    Connect(idMenuDTBSettings,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuDTBSettingsSelected);
    Connect(idSelectARK,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnSelectArkButtonClick);
    Connect(idCreateMIDI,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnCreateMidiButtonClick);
    Connect(idCreateOGG,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnCreateOggButtonClick);
    Connect(idClearLine,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuItemClearLineSelected);
    Connect(idRevalidateOGGs,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnMenuItemRevalidateSelected);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&gh2makerFrame::OnAbout);
    //*)

    initControls() ;

#ifdef _wxMSW_
#else
#endif

    g_icon.CopyFromBitmap( wxBitmap(guitarhero) ) ;
    SetIcon( g_icon ) ;

    Center() ;
}

void gh2makerFrame::OnSetFocus(wxFocusEvent &event)
{
    //wxFocusEvent event2( wxEVT_SET_FOCUS, Grid1->GetId() );

    //wxPostEvent( Grid1, event2 );
    //Grid1->GetEventHandler()->ProcessEvent( event2 );

   //Grid1->Refresh() ;
    event.Skip(false) ;
}

void gh2makerFrame::initControls()
{
    Grid1->ClearGrid() ;

    for ( int i = 0 ; i < 74 ; i++ )
    {
        Grid1->SetReadOnly( i, 2, true ) ;
        Grid1->SetReadOnly( i, 3, true ) ;
        Grid1->SetCellBackgroundColour( i, 2, wxColor( 0xF0, 0x60, 0x60 ) ) ;
        Grid1->SetCellBackgroundColour( i, 3, wxColor( 0xF0, 0x60, 0x60 ) ) ;
        Grid1->SetCellAlignment( i, 2, wxALIGN_CENTRE, wxALIGN_CENTRE ) ;
        Grid1->SetCellAlignment( i, 3, wxALIGN_CENTRE, wxALIGN_CENTRE ) ;
        Grid1->SetCellValue( i, 2, _T("Existing") ) ;
        Grid1->SetCellValue( i, 3, _T("Existing") ) ;
    }


    Grid1->SetColumnWidth( 0, 352 ) ;
    Grid1->SetColumnWidth( 1, 352 ) ;
    Grid1->SetColumnWidth( 2, 90 ) ;
    Grid1->SetColumnWidth( 3, 90 ) ;
    Grid1->SetRowLabelSize( 90 ) ;

    Grid1->SetRowLabelValue( 0,  _T("Tier 1.1") ) ;
    Grid1->SetRowLabelValue( 1,  _T("Tier 1.2") ) ;
    Grid1->SetRowLabelValue( 2,  _T("Tier 1.3") ) ;
    Grid1->SetRowLabelValue( 3,  _T("Tier 1.4") ) ;
    Grid1->SetRowLabelValue( 4,  _T("Tier 1.5") ) ;
    Grid1->SetRowLabelValue( 5,  _T("Tier 1.6") ) ;
    Grid1->SetRowLabelValue( 6,  _T("Tier 2.1") ) ;
    Grid1->SetRowLabelValue( 7,  _T("Tier 2.2") ) ;
    Grid1->SetRowLabelValue( 8,  _T("Tier 2.3") ) ;
    Grid1->SetRowLabelValue( 9,  _T("Tier 2.4") ) ;
    Grid1->SetRowLabelValue( 10, _T("Tier 2.5") ) ;
    Grid1->SetRowLabelValue( 11, _T("Tier 2.6") ) ;
    Grid1->SetRowLabelValue( 12, _T("Tier 3.1") ) ;
    Grid1->SetRowLabelValue( 13, _T("Tier 3.2") ) ;
    Grid1->SetRowLabelValue( 14, _T("Tier 3.3") ) ;
    Grid1->SetRowLabelValue( 15, _T("Tier 3.4") ) ;
    Grid1->SetRowLabelValue( 16, _T("Tier 3.5") ) ;
    Grid1->SetRowLabelValue( 17, _T("Tier 3.6") ) ;
    Grid1->SetRowLabelValue( 18, _T("Tier 4.1") ) ;
    Grid1->SetRowLabelValue( 19, _T("Tier 4.2") ) ;
    Grid1->SetRowLabelValue( 20, _T("Tier 4.3") ) ;
    Grid1->SetRowLabelValue( 21, _T("Tier 4.4") ) ;
    Grid1->SetRowLabelValue( 22, _T("Tier 4.5") ) ;
    Grid1->SetRowLabelValue( 23, _T("Tier 4.6") ) ;
    Grid1->SetRowLabelValue( 24, _T("Tier 5.1") ) ;
    Grid1->SetRowLabelValue( 25, _T("Tier 5.2") ) ;
    Grid1->SetRowLabelValue( 26, _T("Tier 5.3") ) ;
    Grid1->SetRowLabelValue( 27, _T("Tier 5.4") ) ;
    Grid1->SetRowLabelValue( 28, _T("Tier 5.5") ) ;
    Grid1->SetRowLabelValue( 29, _T("Tier 5.6") ) ;
    Grid1->SetRowLabelValue( 30, _T("Tier 6.1") ) ;
    Grid1->SetRowLabelValue( 31, _T("Tier 6.2") ) ;
    Grid1->SetRowLabelValue( 32, _T("Tier 6.3") ) ;
    Grid1->SetRowLabelValue( 33, _T("Tier 6.4") ) ;
    Grid1->SetRowLabelValue( 34, _T("Tier 6.5") ) ;
    Grid1->SetRowLabelValue( 35, _T("Tier 6.6") ) ;
    Grid1->SetRowLabelValue( 36, _T("Tier 7.1") ) ;
    Grid1->SetRowLabelValue( 37, _T("Tier 7.2") ) ;
    Grid1->SetRowLabelValue( 38, _T("Tier 7.3") ) ;
    Grid1->SetRowLabelValue( 39, _T("Tier 7.4") ) ;
    Grid1->SetRowLabelValue( 40, _T("Tier 7.5") ) ;
    Grid1->SetRowLabelValue( 41, _T("Tier 7.6") ) ;
    Grid1->SetRowLabelValue( 42, _T("Tier 8.1") ) ;
    Grid1->SetRowLabelValue( 43, _T("Tier 8.2") ) ;
    Grid1->SetRowLabelValue( 44, _T("Tier 8.3") ) ;
    Grid1->SetRowLabelValue( 45, _T("Tier 8.4") ) ;
    Grid1->SetRowLabelValue( 46, _T("Tier 8.5") ) ;
    Grid1->SetRowLabelValue( 47, _T("Tier 8.6") ) ;
    Grid1->SetRowLabelValue( 48, _T("Bonus 01") ) ;
    Grid1->SetRowLabelValue( 49, _T("Bonus 02") ) ;
    Grid1->SetRowLabelValue( 50, _T("Bonus 03") ) ;
    Grid1->SetRowLabelValue( 51, _T("Bonus 04") ) ;
    Grid1->SetRowLabelValue( 52, _T("Bonus 05") ) ;
    Grid1->SetRowLabelValue( 53, _T("Bonus 06") ) ;
    Grid1->SetRowLabelValue( 54, _T("Bonus 07") ) ;
    Grid1->SetRowLabelValue( 55, _T("Bonus 08") ) ;
    Grid1->SetRowLabelValue( 56, _T("Bonus 09") ) ;
    Grid1->SetRowLabelValue( 57, _T("Bonus 10") ) ;
    Grid1->SetRowLabelValue( 58, _T("Bonus 11") ) ;
    Grid1->SetRowLabelValue( 59, _T("Bonus 12") ) ;
    Grid1->SetRowLabelValue( 60, _T("Bonus 13") ) ;
    Grid1->SetRowLabelValue( 61, _T("Bonus 14") ) ;
    Grid1->SetRowLabelValue( 62, _T("Bonus 15") ) ;
    Grid1->SetRowLabelValue( 63, _T("Bonus 16") ) ;
    Grid1->SetRowLabelValue( 64, _T("Bonus 17") ) ;
    Grid1->SetRowLabelValue( 65, _T("Bonus 18") ) ;
    Grid1->SetRowLabelValue( 66, _T("Bonus 19") ) ;
    Grid1->SetRowLabelValue( 67, _T("Bonus 20") ) ;
    Grid1->SetRowLabelValue( 68, _T("Bonus 21") ) ;
    Grid1->SetRowLabelValue( 69, _T("Bonus 22") ) ;
    Grid1->SetRowLabelValue( 70, _T("Bonus 23") ) ;
    Grid1->SetRowLabelValue( 71, _T("Bonus 24") ) ;
    Grid1->SetRowLabelValue( 72, _T("Bonus 25") ) ;
    Grid1->SetRowLabelValue( 73, _T("Bonus 26") ) ;
    Grid1->SetColLabelValue( 0, _T("Song Name") ) ;
    Grid1->SetColLabelValue( 1, _T("Artist") ) ;
    Grid1->SetColLabelValue( 2, _T("MID") ) ;
    Grid1->SetColLabelValue( 3, _T("OGG") ) ;

    Grid1->DisableDragRowSize() ;

    ButtonFinalize->SetBackgroundColour( wxColor( 0x80, 0xA0, 0xFF ) ) ;

    m_modified = false ;
    m_project_filename = _T("") ;

    //TextArkControl->Connect( wxID_ANY, wxEVT_SET_FOCUS, wxFocusEventHandler(gh2makerFrame::OnSetFocus)) ;

    SetTitle( _T("GH2MakerXBox - Unsaved Project" ) ) ;

    for ( int i = 0 ; i < 74 ; i++ )
    {
        m_midifile[i]  = _T("") ;
        m_oggfile[i]  = _T("") ;
        m_valid_ogg[i] = 0 ;
        m_valid_midi[i] = 0 ;
        Grid1->SetCellValue( i, 0, _T("") ) ;
        Grid1->SetCellValue( i, 1, _T("") ) ;

        m_construct_midi[i] = false ;
        m_construct_ogg[i] = false ;
        m_construct_ogg_delay[i] = 0 ;
        m_construct_ogg_artist[i] = _T("") ;
        m_construct_ogg_title[i] = _T("") ;
        m_construct_ogg_quality[i] = 3 ;

        for ( int j = 0 ; j < 3 ; j++ )
        {
            m_construct_ogg_source_files[i][j] = _T("") ;
        }

        memset( m_construct_ogg_channel_index, 0, sizeof( m_construct_ogg_channel_index ) ) ;
        memset( m_construct_ogg_channel_source, 0, sizeof( m_construct_ogg_channel_source ) ) ;


    }

    m_dtb_note_points = 50 ;
    m_dtb_sustain_points = 25 ;

    m_dtb_easy_unlock_guitars = 0 ;
    m_dtb_encore_venues = 0 ;
    m_dtb_always_star_power = 0;
    m_dtb_free_store = 0 ;
    m_dtb_track_speed_hard = 1400000 ;
    m_dtb_track_speed_expert = 1400000 ;
    m_dtb_enable_save_unlock_cheat = 0 ;
    m_dtb_auto_play = 0 ;
    m_dtb_slop = 100 ;
    m_dtb_hopo_threshold = 170 ;
    m_dtb_remove_orange = 0 ;

    m_dtb_venue_names[0] = _T( "Battle of the Bands") ;
    m_dtb_venue_names[1] = _T( "The Rat Cellar") ;
    m_dtb_venue_names[2] = _T( "The Blackout Bar") ;
    m_dtb_venue_names[3] = _T( "RedOctane Club") ;
    m_dtb_venue_names[4] = _T( "Rock City Theater") ;
    m_dtb_venue_names[5] = _T( "Vans Warped Tour") ;
    m_dtb_venue_names[6] = _T( "The Arena") ;
    m_dtb_venue_names[7] = _T( "Stonehenge") ;

    m_dtb_tier_names[0] = _T( "1. Opening Licks") ;
    m_dtb_tier_names[1] = _T( "2. Amp-Warmers") ;
    m_dtb_tier_names[2] = _T( "3. String Snappers") ;
    m_dtb_tier_names[3] = _T( "4. Thrash and Burn") ;
    m_dtb_tier_names[4] = _T( "5. Return of the Shred") ;
    m_dtb_tier_names[5] = _T( "6. Relentless Riffs") ;
    m_dtb_tier_names[6] = _T( "7. Furious Fretwork") ;
    m_dtb_tier_names[7] = _T( "8. Face-Melters") ;

    m_dtb_difficulty_names[0] = _T( "EASY" ) ;
    m_dtb_difficulty_names[1] = _T( "MEDIUM" ) ;
    m_dtb_difficulty_names[2] = _T( "HARD" ) ;
    m_dtb_difficulty_names[3] = _T( "EXPERT" ) ;

    m_project_dir = m_arkdir = m_source_midi_dir = m_source_ogg_dir = m_dest_midi_dir = m_dest_ogg_dir = wxFileName::GetCwd() ;


    Grid1->SetGridCursor( 0, 0 ) ;
    m_curr_row = 0 ;

    Grid1->SetFocus() ;

}

gh2makerFrame::~gh2makerFrame()
{
    //(*Destroy(gh2makerFrame)
    //*)
}

void gh2makerFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void gh2makerFrame::OnAbout(wxCommandEvent& event)
{
    wxMessageBox( _T("GH2MakerXBox by XPort\n\nSpecial thanks to:\n\nxorloser - This tool would not exist without his arktool sources\n\nMark Constable - Midicomp sources for manipulation of MIDI files\n\nxiph.org - OGG Vorbis libraries"), _T("About GH2MakerXBOX"));

}

void gh2makerFrame::OnGrid1CellLeftClick(wxGridEvent& event)
{
}


int gh2makerFrame::setGridCellDTB( int row, int col, char *dtbentry )
{
    char *value ;

    if ( dtb_get_string( dtbentry, &value ) )
    {
        wxMessageBox( _T("Error reading song/artist info"), _T("Error") ) ;
        return 1 ;
    }

    Grid1->SetCellValue( row, col, wxString::FromAscii( value))  ;

    return 0 ;
}


void gh2makerFrame::importArkData()
{
    float f_value ;
    int i_value;
    char *s_value ;

    wxString filename = wxFileName::CreateTempFileName( _T("gh2makertmp") ) ;

    if ( ! m_arkhdr.GetFile( filename.char_str(), "config/gen/songs.dtb", true ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open config/gen/songs.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_read( filename.char_str() ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open read DTB information for config/gen/songs.dtb"), _T("Error") ) ;
        return ;
    }

    if ( setGridCellDTB( 0, 0, "36.1.1" ) ) return ;
    if ( setGridCellDTB( 0, 1, "36.2.1" ) ) return ;
    if ( setGridCellDTB( 1, 0, "27.1.1" ) ) return ;
    if ( setGridCellDTB( 1, 1, "27.2.1" ) ) return ;
    if ( setGridCellDTB( 2, 0, "13.1.1" ) ) return ;
    if ( setGridCellDTB( 2, 1, "13.2.1" ) ) return ;
    if ( setGridCellDTB( 3, 0, "31.1.1" ) ) return ;
    if ( setGridCellDTB( 3, 1, "31.2.1" ) ) return ;
    if ( setGridCellDTB( 4, 0, "35.1.1" ) ) return ;
    if ( setGridCellDTB( 4, 1, "35.2.1" ) ) return ;
    if ( setGridCellDTB( 5, 0, "33.1.1" ) ) return ;
    if ( setGridCellDTB( 5, 1, "33.2.1" ) ) return ;
    if ( setGridCellDTB( 6, 0, "25.1.1" ) ) return ;
    if ( setGridCellDTB( 6, 1, "25.2.1" ) ) return ;
    if ( setGridCellDTB( 7, 0, "21.1.1" ) ) return ;
    if ( setGridCellDTB( 7, 1, "21.2.1" ) ) return ;
    if ( setGridCellDTB( 8, 0, "6.1.1" ) ) return ;
    if ( setGridCellDTB( 8, 1, "6.2.1" ) ) return ;
    if ( setGridCellDTB( 9, 0, "45.1.1" ) ) return ;
    if ( setGridCellDTB( 9, 1, "45.2.1" ) ) return ;
    if ( setGridCellDTB( 10, 0, "46.1.1" ) ) return ;
    if ( setGridCellDTB( 10, 1, "46.2.1" ) ) return ;
    if ( setGridCellDTB( 11, 0, "40.1.1" ) ) return ;
    if ( setGridCellDTB( 11, 1, "40.2.1" ) ) return ;
    if ( setGridCellDTB( 12, 0, "5.1.1" ) ) return ;
    if ( setGridCellDTB( 12, 1, "5.2.1" ) ) return ;
    if ( setGridCellDTB( 13, 0, "32.1.1" ) ) return ;
    if ( setGridCellDTB( 13, 1, "32.2.1" ) ) return ;
    if ( setGridCellDTB( 14, 0, "23.1.1" ) ) return ;
    if ( setGridCellDTB( 14, 1, "23.2.1" ) ) return ;
    if ( setGridCellDTB( 15, 0, "2.1.1" ) ) return ;
    if ( setGridCellDTB( 15, 1, "2.2.1" ) ) return ;
    if ( setGridCellDTB( 16, 0, "39.1.1" ) ) return ;
    if ( setGridCellDTB( 16, 1, "39.2.1" ) ) return ;
    if ( setGridCellDTB( 17, 0, "43.1.1" ) ) return ;
    if ( setGridCellDTB( 17, 1, "43.2.1" ) ) return ;
    if ( setGridCellDTB( 18, 0, "26.1.1" ) ) return ;
    if ( setGridCellDTB( 18, 1, "26.2.1" ) ) return ;
    if ( setGridCellDTB( 19, 0, "14.1.1" ) ) return ;
    if ( setGridCellDTB( 19, 1, "14.2.1" ) ) return ;
    if ( setGridCellDTB( 20, 0, "11.1.1" ) ) return ;
    if ( setGridCellDTB( 20, 1, "11.2.1" ) ) return ;
    if ( setGridCellDTB( 21, 0, "44.1.1" ) ) return ;
    if ( setGridCellDTB( 21, 1, "44.2.1" ) ) return ;
    if ( setGridCellDTB( 22, 0, "3.1.1" ) ) return ;
    if ( setGridCellDTB( 22, 1, "3.2.1" ) ) return ;
    if ( setGridCellDTB( 23, 0, "37.1.1" ) ) return ;
    if ( setGridCellDTB( 23, 1, "37.2.1" ) ) return ;
    if ( setGridCellDTB( 24, 0, "29.1.1" ) ) return ;
    if ( setGridCellDTB( 24, 1, "29.2.1" ) ) return ;
    if ( setGridCellDTB( 25, 0, "38.1.1" ) ) return ;
    if ( setGridCellDTB( 25, 1, "38.2.1" ) ) return ;
    if ( setGridCellDTB( 26, 0, "17.1.1" ) ) return ;
    if ( setGridCellDTB( 26, 1, "17.2.1" ) ) return ;
    if ( setGridCellDTB( 27, 0, "16.1.1" ) ) return ;
    if ( setGridCellDTB( 27, 1, "16.2.1" ) ) return ;
    if ( setGridCellDTB( 28, 0, "0.1.1" ) ) return ;
    if ( setGridCellDTB( 28, 1, "0.2.1" ) ) return ;
    if ( setGridCellDTB( 29, 0, "20.1.1" ) ) return ;
    if ( setGridCellDTB( 29, 1, "20.2.1" ) ) return ;
    if ( setGridCellDTB( 30, 0, "7.1.1" ) ) return ;
    if ( setGridCellDTB( 30, 1, "7.2.1" ) ) return ;
    if ( setGridCellDTB( 31, 0, "41.1.1" ) ) return ;
    if ( setGridCellDTB( 31, 1, "41.2.1" ) ) return ;
    if ( setGridCellDTB( 32, 0, "8.1.1" ) ) return ;
    if ( setGridCellDTB( 32, 1, "8.2.1" ) ) return ;
    if ( setGridCellDTB( 33, 0, "18.1.1" ) ) return ;
    if ( setGridCellDTB( 33, 1, "18.2.1" ) ) return ;
    if ( setGridCellDTB( 34, 0, "10.1.1" ) ) return ;
    if ( setGridCellDTB( 34, 1, "10.2.1" ) ) return ;
    if ( setGridCellDTB( 35, 0, "34.1.1" ) ) return ;
    if ( setGridCellDTB( 35, 1, "34.2.1" ) ) return ;
    if ( setGridCellDTB( 36, 0, "22.1.1" ) ) return ;
    if ( setGridCellDTB( 36, 1, "22.2.1" ) ) return ;
    if ( setGridCellDTB( 37, 0, "42.1.1" ) ) return ;
    if ( setGridCellDTB( 37, 1, "42.2.1" ) ) return ;
    if ( setGridCellDTB( 38, 0, "30.1.1" ) ) return ;
    if ( setGridCellDTB( 38, 1, "30.2.1" ) ) return ;
    if ( setGridCellDTB( 39, 0, "19.1.1" ) ) return ;
    if ( setGridCellDTB( 39, 1, "19.2.1" ) ) return ;
    if ( setGridCellDTB( 40, 0, "28.1.1" ) ) return ;
    if ( setGridCellDTB( 40, 1, "28.2.1" ) ) return ;
    if ( setGridCellDTB( 41, 0, "47.1.1" ) ) return ;
    if ( setGridCellDTB( 41, 1, "47.2.1" ) ) return ;
    if ( setGridCellDTB( 42, 0, "1.1.1" ) ) return ;
    if ( setGridCellDTB( 42, 1, "1.2.1" ) ) return ;
    if ( setGridCellDTB( 43, 0, "4.1.1" ) ) return ;
    if ( setGridCellDTB( 43, 1, "4.2.1" ) ) return ;
    if ( setGridCellDTB( 44, 0, "15.1.1" ) ) return ;
    if ( setGridCellDTB( 44, 1, "15.2.1" ) ) return ;
    if ( setGridCellDTB( 45, 0, "24.1.1" ) ) return ;
    if ( setGridCellDTB( 45, 1, "24.2.1" ) ) return ;
    if ( setGridCellDTB( 46, 0, "12.1.1" ) ) return ;
    if ( setGridCellDTB( 46, 1, "12.2.1" ) ) return ;
    if ( setGridCellDTB( 47, 0, "9.1.1" ) ) return ;
    if ( setGridCellDTB( 47, 1, "9.2.1" ) ) return ;
    if ( setGridCellDTB( 48, 0, "65.1.1" ) ) return ;
    if ( setGridCellDTB( 48, 1, "65.2.1" ) ) return ;
    if ( setGridCellDTB( 49, 0, "48.1.1" ) ) return ;
    if ( setGridCellDTB( 49, 1, "48.2.1" ) ) return ;
    if ( setGridCellDTB( 50, 0, "49.1.1" ) ) return ;
    if ( setGridCellDTB( 50, 1, "49.2.1" ) ) return ;
    if ( setGridCellDTB( 51, 0, "72.1.1" ) ) return ;
    if ( setGridCellDTB( 51, 1, "72.2.1" ) ) return ;
    if ( setGridCellDTB( 52, 0, "50.1.1" ) ) return ;
    if ( setGridCellDTB( 52, 1, "50.2.1" ) ) return ;
    if ( setGridCellDTB( 53, 0, "51.1.1" ) ) return ;
    if ( setGridCellDTB( 53, 1, "51.2.1" ) ) return ;
    if ( setGridCellDTB( 54, 0, "52.1.1" ) ) return ;
    if ( setGridCellDTB( 54, 1, "52.2.1" ) ) return ;
    if ( setGridCellDTB( 55, 0, "53.1.1" ) ) return ;
    if ( setGridCellDTB( 55, 1, "53.2.1" ) ) return ;
    if ( setGridCellDTB( 56, 0, "55.1.1" ) ) return ;
    if ( setGridCellDTB( 56, 1, "55.2.1" ) ) return ;
    if ( setGridCellDTB( 57, 0, "56.1.1" ) ) return ;
    if ( setGridCellDTB( 57, 1, "56.2.1" ) ) return ;
    if ( setGridCellDTB( 58, 0, "57.1.1" ) ) return ;
    if ( setGridCellDTB( 58, 1, "57.2.1" ) ) return ;
    if ( setGridCellDTB( 59, 0, "58.1.1" ) ) return ;
    if ( setGridCellDTB( 59, 1, "58.2.1" ) ) return ;
    if ( setGridCellDTB( 60, 0, "54.1.1" ) ) return ;
    if ( setGridCellDTB( 60, 1, "54.2.1" ) ) return ;
    if ( setGridCellDTB( 61, 0, "59.1.1" ) ) return ;
    if ( setGridCellDTB( 61, 1, "59.2.1" ) ) return ;
    if ( setGridCellDTB( 62, 0, "60.1.1" ) ) return ;
    if ( setGridCellDTB( 62, 1, "60.2.1" ) ) return ;
    if ( setGridCellDTB( 63, 0, "61.1.1" ) ) return ;
    if ( setGridCellDTB( 63, 1, "61.2.1" ) ) return ;
    if ( setGridCellDTB( 64, 0, "62.1.1" ) ) return ;
    if ( setGridCellDTB( 64, 1, "62.2.1" ) ) return ;
    if ( setGridCellDTB( 65, 0, "63.1.1" ) ) return ;
    if ( setGridCellDTB( 65, 1, "63.2.1" ) ) return ;
    if ( setGridCellDTB( 66, 0, "64.1.1" ) ) return ;
    if ( setGridCellDTB( 66, 1, "64.2.1" ) ) return ;
    if ( setGridCellDTB( 67, 0, "66.1.1" ) ) return ;
    if ( setGridCellDTB( 67, 1, "66.2.1" ) ) return ;
    if ( setGridCellDTB( 68, 0, "67.1.1" ) ) return ;
    if ( setGridCellDTB( 68, 1, "67.2.1" ) ) return ;
    if ( setGridCellDTB( 69, 0, "68.1.1" ) ) return ;
    if ( setGridCellDTB( 69, 1, "68.2.1" ) ) return ;
    if ( setGridCellDTB( 70, 0, "69.1.1" ) ) return ;
    if ( setGridCellDTB( 70, 1, "69.2.1" ) ) return ;
    if ( setGridCellDTB( 71, 0, "70.1.1" ) ) return ;
    if ( setGridCellDTB( 71, 1, "70.2.1" ) ) return ;
    if ( setGridCellDTB( 72, 0, "71.1.1" ) ) return ;
    if ( setGridCellDTB( 72, 1, "71.2.1" ) ) return ;
    if ( setGridCellDTB( 73, 0, "73.1.1" ) ) return ;
    if ( setGridCellDTB( 73, 1, "73.2.1" ) ) return ;

    ::wxRemoveFile( filename ) ;

    filename = wxFileName::CreateTempFileName( _T("gh2makertmp") ) ;

    if ( ! m_arkhdr.GetFile( filename.char_str(), "ui/eng/gen/locale.dtb", true ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open ui/eng/gen/locale.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_read( filename.char_str() ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open read DTB information for ui/eng/gen/locale.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_get_string( "122.1", &s_value ) == 0 ) m_dtb_venue_names[0] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "120.1", &s_value ) == 0 ) m_dtb_venue_names[1] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "121.1", &s_value ) == 0 ) m_dtb_venue_names[2] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "115.1", &s_value ) == 0 ) m_dtb_venue_names[3] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "118.1", &s_value ) == 0 ) m_dtb_venue_names[4] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "117.1", &s_value ) == 0 ) m_dtb_venue_names[5] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "116.1", &s_value ) == 0 ) m_dtb_venue_names[6] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "119.1", &s_value ) == 0 ) m_dtb_venue_names[7] = wxString::FromAscii( s_value );

    if ( dtb_get_string( "684.1", &s_value ) == 0 ) m_dtb_tier_names[0] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "685.1", &s_value ) == 0 ) m_dtb_tier_names[1] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "686.1", &s_value ) == 0 ) m_dtb_tier_names[2] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "687.1", &s_value ) == 0 ) m_dtb_tier_names[3] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "688.1", &s_value ) == 0 ) m_dtb_tier_names[4] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "689.1", &s_value ) == 0 ) m_dtb_tier_names[5] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "690.1", &s_value ) == 0 ) m_dtb_tier_names[6] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "691.1", &s_value ) == 0 ) m_dtb_tier_names[7] = wxString::FromAscii( s_value );

    if ( dtb_get_string( "706.1", &s_value ) == 0 ) m_dtb_difficulty_names[0] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "707.1", &s_value ) == 0 ) m_dtb_difficulty_names[1] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "708.1", &s_value ) == 0 ) m_dtb_difficulty_names[2] = wxString::FromAscii( s_value );
    if ( dtb_get_string( "709.1", &s_value ) == 0 ) m_dtb_difficulty_names[3] = wxString::FromAscii( s_value );

    ::wxRemoveFile( filename ) ;


    filename = wxFileName::CreateTempFileName( _T("gh2makertmp") ) ;

    if ( ! m_arkhdr.GetFile( filename.char_str(), "config/gen/scoring.dtb", true ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open config/gen/scoring.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_read( filename.char_str() ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open read DTB information for config/gen/scoring.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_get_int( "0.1.1", &i_value ) )
        m_dtb_note_points = 50 ;
    else
        m_dtb_note_points = i_value ;

    if ( dtb_get_int( "0.2.1", &i_value ) )
        m_dtb_sustain_points = 25 ;
    else
        m_dtb_sustain_points = i_value ;

    ::wxRemoveFile( filename ) ;


    filename = wxFileName::CreateTempFileName( _T("gh2makertmp") ) ;

    if ( ! m_arkhdr.GetFile( filename.char_str(), "config/gen/track_graphics.dtb", true ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open config/gen/track_graphics.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_read( filename.char_str() ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open read DTB information for config/gen/track_graphics.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_get_float( "9.3.1", &f_value ) )
        m_dtb_track_speed_hard = 1400000 ;
    else
        m_dtb_track_speed_hard = (int)( f_value * 1000000.0f) ;

    if ( dtb_get_float( "9.4.1", &f_value ) )
        m_dtb_track_speed_expert = 1400000 ;
    else
        m_dtb_track_speed_expert = (int)( f_value * 1000000.0f) ;

    ::wxRemoveFile( filename ) ;


    filename = wxFileName::CreateTempFileName( _T("gh2makertmp") ) ;

    if ( ! m_arkhdr.GetFile( filename.char_str(), "config/gen/beatmatcher.dtb", true ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open config/gen/beatmatcher.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_read( filename.char_str() ) )
    {
        ::wxRemoveFile( filename ) ;
        wxMessageBox( _T("Could not open read DTB information for config/gen/beatmatcher.dtb"), _T("Error") ) ;
        return ;
    }

    if ( dtb_get_int( "2.1.1", &i_value ) )
        m_dtb_slop = 100 ;
    else
        m_dtb_slop = i_value ;

    if ( dtb_get_int( "3.1.1", &i_value ) )
        m_dtb_hopo_threshold = 170 ;
    else
        m_dtb_hopo_threshold = i_value ;

    ::wxRemoveFile( filename ) ;



}

int gh2makerFrame::loadProject()
{
    wxFileDialog LoadDialog(
		this, _("Choose the GH2 Project file to open"), m_project_dir, wxEmptyString,
		_("GH2 Project files (*.gh2)|*.gh2"),
//		_("*|*"),
		wxFD_OPEN|wxFD_FILE_MUST_EXIST|wxFD_CHANGE_DIR, wxDefaultPosition);

    LoadDialog.Center() ;
	// Creates a "open file" dialog with 4 file types
	if (LoadDialog.ShowModal() == wxID_OK) // if the user click "Open" instead of "Cancel"
	{
	    IniFile *inifile ;
	    char keyvalue[50] ;

	    m_project_dir = LoadDialog.GetDirectory() ;

        m_project_filename = LoadDialog.GetPath() ;

        SetTitle( wxString( _T( "GH2MakerXBox - " ) ).Append( LoadDialog.GetFilename() ) ) ;

        m_modified = false ;


	    inifile = new IniFile( LoadDialog.GetPath() ) ;

        m_arkdir = inifile->GetIniString( "DEFAULT", "arkdir", m_arkdir.char_str() ) ;
        m_project_dir = inifile->GetIniString( "DEFAULT", "projectdir", m_project_dir.char_str() ) ;
        m_source_midi_dir = inifile->GetIniString( "DEFAULT", "sourcemididir", m_source_midi_dir.char_str() ) ;
        m_source_ogg_dir = inifile->GetIniString( "DEFAULT", "sourceoggdir", m_source_ogg_dir.char_str() ) ;
        m_dest_midi_dir = inifile->GetIniString( "DEFAULT", "destmididir", m_dest_midi_dir.char_str() ) ;
        m_dest_ogg_dir = inifile->GetIniString( "DEFAULT", "destoggdir", m_dest_ogg_dir.char_str() ) ;
        m_dtb_remove_orange = inifile->GetIniInt( "DEFAULT", "remove_orange", m_dtb_remove_orange ) ;
        m_dtb_note_points = inifile->GetIniInt( "DEFAULT", "note_points", m_dtb_note_points ) ;
        m_dtb_sustain_points  = inifile->GetIniInt( "DEFAULT", "sustain_points", m_dtb_sustain_points  ) ;
        m_dtb_easy_unlock_guitars  = inifile->GetIniInt( "DEFAULT", "easy_guitars", m_dtb_easy_unlock_guitars  ) ;
        m_dtb_encore_venues  = inifile->GetIniInt( "DEFAULT", "encore_venues", m_dtb_encore_venues  ) ;
        m_dtb_always_star_power  = inifile->GetIniInt( "DEFAULT", "always_star_power", m_dtb_always_star_power  ) ;
        m_dtb_free_store  = inifile->GetIniInt( "DEFAULT", "free_store", m_dtb_free_store  ) ;
        m_dtb_track_speed_hard  = inifile->GetIniInt( "DEFAULT", "speed_hard", m_dtb_track_speed_hard ) ;
        m_dtb_track_speed_expert  = inifile->GetIniInt( "DEFAULT", "speed_expert", m_dtb_track_speed_expert ) ;
        m_dtb_enable_save_unlock_cheat  = inifile->GetIniInt( "DEFAULT", "save_unlock", m_dtb_enable_save_unlock_cheat  ) ;
        m_dtb_auto_play  = inifile->GetIniInt( "DEFAULT", "auto_play", m_dtb_auto_play  ) ;
        m_dtb_slop  = inifile->GetIniInt( "DEFAULT", "slop", m_dtb_slop  ) ;
        m_dtb_hopo_threshold  = inifile->GetIniInt( "DEFAULT", "hopo_threshold", m_dtb_hopo_threshold  ) ;

        for ( int i = 0 ; i < 8 ; i++ )
        {
            sprintf( keyvalue, "tier_name_%d", i ) ;
            m_dtb_tier_names[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_dtb_tier_names[i].char_str() ) ;
        }
        for ( int i = 0 ; i < 8 ; i++ )
        {
            sprintf( keyvalue, "venue_name_%d", i ) ;
            m_dtb_venue_names[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_dtb_venue_names[i].char_str() ) ;
        }
        for ( int i = 0 ; i < 4 ; i++ )
        {
            sprintf( keyvalue, "difficulty_name_%d", i ) ;
            m_dtb_difficulty_names[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_dtb_difficulty_names[i].char_str() ) ;
        }
        for ( int i = 0 ; i < 74 ; i++ )
        {
            sprintf( keyvalue, "song_%d_name", i ) ;
            Grid1->SetCellValue( i, 0, inifile->GetIniString( "DEFAULT", keyvalue, Grid1->GetCellValue( i, 0 ).char_str() ) ) ;
            sprintf( keyvalue, "song_%d_artist", i ) ;
            Grid1->SetCellValue( i, 1, inifile->GetIniString( "DEFAULT", keyvalue, Grid1->GetCellValue( i, 1 ).char_str() ) ) ;
            sprintf( keyvalue, "song_%d_midi", i ) ;
            m_midifile[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_midifile[i].char_str() ) ;
            sprintf( keyvalue, "song_%d_ogg", i ) ;
            m_oggfile[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_oggfile[i].char_str() ) ;
            sprintf( keyvalue, "song_%d_midi_valid", i ) ;
            m_valid_midi[i] = inifile->GetIniInt( "DEFAULT", keyvalue, m_valid_midi[i] )  ;
            sprintf( keyvalue, "song_%d_ogg_valid", i ) ;
            m_valid_ogg[i] = inifile->GetIniInt( "DEFAULT", keyvalue, m_valid_ogg[i] ) ;

            if ( m_valid_midi[i] == 1)
                m_valid_midi[i] = wxFileExists( m_midifile[i] ) ? 1 : 0  ;

            if ( m_valid_ogg[i] == 1 )
                m_valid_ogg[i] = wxFileExists( m_oggfile[i] ) ? 1 : 0 ;

            sprintf( keyvalue, "song_%d_construct_midi", i ) ;
            m_construct_midi[i] = inifile->GetIniInt( "DEFAULT", keyvalue, m_construct_midi[i] ? 1 : 0 ) == 1 ? true : false ;

            sprintf( keyvalue, "song_%d_construct_ogg", i ) ;
            m_construct_ogg[i] = inifile->GetIniInt( "DEFAULT", keyvalue, m_construct_ogg[i] ? 1 : 0 ) == 1 ? true : false ;

            Grid1->SetCellBackgroundColour( i, 2, (m_valid_midi[i]==1) ? wxColor( 0x60, 0xF0, 0x60 ) : ( (m_valid_midi[i]==0) ? wxColor( 0xF0, 0x60, 0x60 ) : wxColor( 0xF0,0xF0,0x00) ) ) ;
            Grid1->SetCellBackgroundColour( i, 3, (m_valid_ogg[i]==1) ? wxColor( 0x60, 0xF0, 0x60 ) : ( (m_valid_ogg[i]==0) ? wxColor( 0xF0, 0x60, 0x60 ) : wxColor( 0xF0,0xF0,0x00) ) ) ;
            if ( m_valid_midi[i] == 1 )
            {
                Grid1->SetCellValue( i, 2, m_construct_midi[i] ? _T("New/Convert") : _T("New") ) ;
            }
            else if ( m_valid_midi[i] == 2 )
            {
                Grid1->SetCellValue( i, 2, _T("Blank") ) ;
            }

            if ( m_valid_ogg[i] )
            {
                Grid1->SetCellValue( i, 3, m_construct_ogg[i] ? _T("New/Convert") : _T("New") ) ;
            }
            else if ( m_valid_ogg[i] == 2 )
            {
                Grid1->SetCellValue( i, 3, _T("Blank") ) ;
            }

            if ( m_construct_ogg[i] )
            {
                sprintf( keyvalue, "song_%d_construct_ogg_delay", i ) ;
                m_construct_ogg_delay[i] = inifile->GetIniInt( "DEFAULT", keyvalue, m_construct_ogg_delay[i] ) ;
                sprintf( keyvalue, "song_%d_construct_ogg_quality", i ) ;
                m_construct_ogg_quality[i] = inifile->GetIniInt( "DEFAULT", keyvalue, m_construct_ogg_quality[i] ) ;
                sprintf( keyvalue, "song_%d_construct_ogg_title", i ) ;
                m_construct_ogg_title[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_construct_ogg_title[i].char_str() ) ;
                sprintf( keyvalue, "song_%d_construct_ogg_artist", i ) ;
                m_construct_ogg_artist[i] = inifile->GetIniString( "DEFAULT", keyvalue, m_construct_ogg_artist[i].char_str() ) ;

                for ( int j = 0 ; j < 3 ; j++ )
                {
                    sprintf( keyvalue, "song_%d_construct_ogg_source_file_%d", i, j ) ;
                    m_construct_ogg_source_files[i][j] = inifile->GetIniString( "DEFAULT", keyvalue, m_construct_ogg_source_files[i][j].char_str() ) ;
                }
                for ( int j = 0 ; j < 6 ; j++ )
                {
                    sprintf( keyvalue, "song_%d_construct_ogg_channel_source_%d", i, j ) ;
                    m_construct_ogg_channel_source[i][j] = inifile->GetIniInt( "DEFAULT", keyvalue, m_construct_ogg_channel_source[i][j] ) ;

                    sprintf( keyvalue, "song_%d_construct_ogg_channel_index_%d", i, j ) ;
                    m_construct_ogg_channel_index[i][j] = inifile->GetIniInt( "DEFAULT", keyvalue, m_construct_ogg_channel_index[i][j] ) ;
                }
            }

        }
        TextMidiControl->SetValue( m_midifile[m_curr_row] ) ;
        TextOggControl->SetValue( m_oggfile[m_curr_row] ) ;
        TextArkControl->SetValue( m_arkdir ) ;


        Refresh() ;
	}

	return 0 ;
}

int gh2makerFrame::saveProject( bool forceSave )
{
    FILE *inifile ;
    int  answer = wxID_OK;
    wxString filename ;


    if ( forceSave || ( m_project_filename.Length() == 0 ) )
    {
        while ( answer == wxID_OK)
        {

            wxFileDialog SaveDialog(
                this, _("Choose the GH2 Project file to save"), m_project_dir, wxEmptyString,
                //		_("*|*"),
                _("GH2 Project files (*.gh2)|*.gh2|"),
                wxSAVE|wxCHANGE_DIR, wxDefaultPosition) ;

            SaveDialog.Center() ;

            answer = SaveDialog.ShowModal() ;

            if ( answer != wxID_OK )
            {
                m_project_filename = _T("") ;
                return 0 ;
            }

            m_project_dir = SaveDialog.GetDirectory() ;

            filename = SaveDialog.GetPath() ;


            if ( ! filename.EndsWith( _T(".gh2") ) )
            {
                filename.Append( _T( ".gh2" ) );
            }

            if ( wxFileExists( filename ) )
            {
                if ( wxMessageBox( _T("The file you selected already exists.\n\nDo you want to overwrite it?"), _T("File Exists"), wxYES_NO|wxICON_QUESTION ) == wxNO )
                {
                    continue ;
                }

            }
            m_project_filename = filename ;
            break ;


        }
    }
    inifile = fopen( m_project_filename.char_str(), "wb" ) ;

    if ( inifile == NULL )
    {
        wxMessageBox( _T("Could not open file for writing"), _T("Error") ) ;
        return 1 ;
    }

    SetTitle( wxString( _T( "GH2MakerXBox - " ) ).Append( wxFileName( m_project_filename ).GetFullName() ) ) ;

    m_modified = false;

    fprintf( inifile, "[DEFAULT]\narkdir=%s\n", (char*)m_arkdir.char_str() ) ;
    fprintf( inifile, "projectdir=%s\n", (char*)m_project_dir.char_str() ) ;
    fprintf( inifile, "sourcemididir=%s\n", (char*)m_source_midi_dir.char_str() ) ;
    fprintf( inifile, "sourceoggdir=%s\n", (char*)m_source_ogg_dir.char_str() ) ;
    fprintf( inifile, "destmididir=%s\n", (char*)m_dest_midi_dir.char_str() ) ;
    fprintf( inifile, "destoggdir=%s\n", (char*)m_dest_ogg_dir.char_str() ) ;
    fprintf( inifile, "remove_orange=%d\n", m_dtb_remove_orange ) ;
    fprintf( inifile, "note_points=%d\n", m_dtb_note_points ) ;
    fprintf( inifile, "sustain_points=%d\n", m_dtb_sustain_points  ) ;
    fprintf( inifile, "easy_guitars=%d\n", m_dtb_easy_unlock_guitars  ) ;
    fprintf( inifile, "encore_venues=%d\n", m_dtb_encore_venues  ) ;
    fprintf( inifile, "always_star_power=%d\n", m_dtb_always_star_power  ) ;
    fprintf( inifile, "free_store=%d\n", m_dtb_free_store  ) ;
    fprintf( inifile, "speed_hard=%d\n", m_dtb_track_speed_hard ) ;
    fprintf( inifile, "speed_expert=%d\n", m_dtb_track_speed_expert ) ;
    fprintf( inifile, "save_unlock=%d\n", m_dtb_enable_save_unlock_cheat  ) ;
    fprintf( inifile, "auto_play=%d\n", m_dtb_auto_play  ) ;
    fprintf( inifile, "slop=%d\n", m_dtb_slop  ) ;
    fprintf( inifile, "hopo_threshold=%d\n", m_dtb_hopo_threshold  ) ;

    for ( int i = 0 ; i < 8 ; i++ )
    {
        fprintf( inifile, "tier_name_%d=%s\n", i, (char*)m_dtb_tier_names[i].char_str() ) ;
    }
    for ( int i = 0 ; i < 8 ; i++ )
    {
        fprintf( inifile, "venue_name_%d=%s\n", i, (char*)m_dtb_venue_names[i].char_str() ) ;
    }
    for ( int i = 0 ; i < 4 ; i++ )
    {
        fprintf( inifile, "difficulty_name_%d=%s\n", i, (char*)m_dtb_difficulty_names[i].char_str() ) ;
    }

    for ( int i = 0 ; i < 74 ; i++ )
    {
        fprintf( inifile, "song_%d_name=%s\n", i, (char*)Grid1->GetCellValue( i, 0 ).char_str() ) ;
        fprintf( inifile, "song_%d_artist=%s\n", i, (char*)Grid1->GetCellValue( i, 1 ).char_str() ) ;
        fprintf( inifile, "song_%d_midi=%s\n", i, (char*)m_midifile[i].char_str() ) ;
        fprintf( inifile, "song_%d_ogg=%s\n", i, (char*)m_oggfile[i].char_str() ) ;
        fprintf( inifile, "song_%d_midi_valid=%d\n", i, m_valid_midi[i]  ) ;
        fprintf( inifile, "song_%d_ogg_valid=%d\n", i, m_valid_ogg[i]  ) ;

        fprintf( inifile, "song_%d_construct_midi=%d\n", i, m_construct_midi[i] ? 1 : 0 ) ;
        fprintf( inifile, "song_%d_construct_ogg=%d\n", i, m_construct_ogg[i] ? 1 : 0 ) ;

        if ( m_construct_ogg[i] )
        {
            fprintf( inifile, "song_%d_construct_ogg_delay=%d\n", i, m_construct_ogg_delay[i] ) ;
            fprintf( inifile, "song_%d_construct_ogg_quality=%d\n", i, m_construct_ogg_quality[i] ) ;
            fprintf( inifile, "song_%d_construct_ogg_artist=%s\n", i, (char*)m_construct_ogg_artist[i].char_str() ) ;
            fprintf( inifile, "song_%d_construct_ogg_title=%s\n", i, (char*)m_construct_ogg_title[i].char_str() ) ;

            for ( int j = 0 ; j < 3 ; j++ )
            {
                fprintf( inifile, "song_%d_construct_ogg_source_file_%d=%s\n", i, j, (char*)m_construct_ogg_source_files[i][j].char_str() ) ;
            }
            for ( int j = 0 ; j < 6 ; j++ )
            {
                fprintf( inifile, "song_%d_construct_ogg_channel_source_%d=%d\n", i, j, m_construct_ogg_channel_source[i][j] ) ;
                fprintf( inifile, "song_%d_construct_ogg_channel_index_%d=%d\n", i, j, m_construct_ogg_channel_index[i][j] ) ;
            }
        }
    }

    fclose( inifile ) ;

	return 0 ;
}

void gh2makerFrame::OnSelectArkButtonClick(wxCommandEvent& event)
{
    wxFileDialog OpenDialog(
		this, _("Choose the ARK file to open"), m_arkdir, wxEmptyString,
		_("ARK files (*.ark)|*.ark"),
		wxFD_OPEN|wxFD_CHANGE_DIR|wxFD_FILE_MUST_EXIST, wxDefaultPosition);

    OpenDialog.Center() ;

	// Creates a "open file" dialog with 4 file types
	if (OpenDialog.ShowModal() == wxID_OK) // if the user click "Open" instead of "Cancel"
	{
        if( !m_arkhdr.Open(OpenDialog.GetDirectory().char_str()) )
        {
                wxMessageBox( _T("Error opening ark/hdr files"), _T("Error"));
        }
        else
        {
            //if ( m_arkhdr.FileExists( "songs/hush/hush.mogg" ) )
            {
                if ( wxMessageBox( _T("Do you want to import all of the ARK data?"), _T("Import data?"), wxYES_NO | wxICON_QUESTION ) == wxYES )
                {
                    importArkData() ;
                }

                m_arkdir = OpenDialog.GetDirectory() ;
                m_arkhdr.Close() ;
                this->TextArkControl->SetValue( m_arkdir ) ;
            }
            /*
            else
            {
                wxMessageBox( _T("The ARK you selected does not have certain songs like Hush and Cherry Pie

            }
*/
        }
	}
    Grid1->SetFocus() ;
}

void gh2makerFrame::constructMidi( bool forceConvert )
{
    wxString filename ;
    wxString tempname ;
    wxString line ;
    bool addit = false ;
    int answer = 0 ;

    wxFileDialog OpenDialog(
		this, _("Choose the MIDI file to open"), m_source_ogg_dir, wxEmptyString,
		_("MIDI files (*.mid)|*.mid"),
		wxFD_OPEN|wxFD_CHANGE_DIR|wxFD_FILE_MUST_EXIST, wxDefaultPosition);

    OpenDialog.Center() ;

	if (OpenDialog.ShowModal() == wxID_OK)
	{

	    m_source_ogg_dir = OpenDialog.GetDirectory() ;
        filename = OpenDialog.GetPath() ;

        tempname = wxFileName::CreateTempFileName( _T("gh2makertmp") ) ;
	    switch ( midicomp_decompile( OpenDialog.GetPath().char_str(), tempname.char_str() ) )
	    {
	        case -1 : wxMessageBox( _T("Could not open file for reading."), _T("Error") ) ; break ;
	        case -2 : wxMessageBox( _T("Could not open file for writing."), _T("Error") ) ; break ;
	        case 1  :
	        {
                MidiFile midifile( tempname ) ;

                if ( midifile.isValid() && (!forceConvert) )
                {
                    addit = true ;
                    filename = OpenDialog.GetPath() ;
                }
                else
                {
                    if ( forceConvert )
                    {
                        addit = true ;
                    }
                    else
                    {
                        answer = wxMessageBox( _T( "This MIDI file failed certain validation checks.\n\nIt probably won't work in its current state.\n\nDo you wish to allow GH2Maker to convert it into a usable format?\n\nIf you select \"No\" then it will be left as is and it will be added into your project.\n\nOnly select \"No\" if you really know what you're doing.\n\nSelect \"Cancel\" to abort this process altogether." ) ,
                                               _T( "MIDI Failed Validation" ), wxCANCEL | wxYES_NO | wxICON_ERROR ) ;

                        if ( answer == wxYES )
                        {
                            forceConvert = true ;
                            addit = true ;
                        }
                        else if ( answer == wxNO )
                        {
                            addit = true ;
                        }
                        else
                        {
                            ::wxRemoveFile( tempname ) ;
                            return ;
                        }
                    }
/*
                    if ( addit )
                    {
                        if ( forceConvert )
                        {
                            answer = wxID_OK ;

                            while ( answer == wxID_OK)
                            {

                                wxFileDialog SaveDialog(
                                    this, _("Select new file into which to write clean MIDI data"), m_dest_midi_dir, wxEmptyString,
                                    //		_("*|*"),
                                    _("MIDI files (*.mid)|*.mid|"),
                                    wxSAVE|wxCHANGE_DIR, wxDefaultPosition) ;


                                answer = SaveDialog.ShowModal() ;

                                m_dest_midi_dir = SaveDialog.GetDirectory() ;

                                filename = SaveDialog.GetPath() ;


                                if ( ! filename.EndsWith( _T(".mid") ) )
                                {
                                    filename.Append( _T( ".mid" ) );
                                }

                                if ( wxFileExists( filename ) )
                                {
                                    if ( wxMessageBox( _T("The file you selected already exists.\n\nDo you want to overwrite it?"), _T("File Exists"), wxYES_NO|wxICON_QUESTION ) == wxNO )
                                    {
                                        continue ;
                                    }

                                }
                                break ;


                            }
                            if ( answer != wxID_OK )
                            {
                                ::wxRemoveFile( tempname ) ;
                                return  ;
                            }

                            if ( midifile.writeGH2Format( filename ) )
                            {
                                wxMessageBox( _T( "Error during writing of new MID file." ), _T( "Error" ), wxICON_ERROR ) ;
                                ::wxRemoveFile( tempname ) ;
                                return  ;
                            }
                        }
                    }
                */

                }
                m_midifile[m_curr_row] = filename ;
                TextMidiControl->SetValue( filename ) ;
                Grid1->SetCellBackgroundColour( m_curr_row, 2, wxColor( 0x60, 0xF0, 0x60 ) ) ;
                Grid1->SetCellValue( m_curr_row, 2, forceConvert ? _T( "New/Convert" ) : _T("New") ) ;
                Grid1->Refresh() ;
                TextMidiControl->Refresh() ;
                m_valid_midi[m_curr_row] = 1 ;
                m_construct_midi[m_curr_row] = forceConvert ;
                m_modified = true ;
                if ( m_project_filename.Length() > 0 )
                    SetTitle( wxString( _T( "GH2MakerXBox - *" ) ).Append( wxFileName( m_project_filename ).GetFullName() ) ) ;
                else
                    SetTitle( wxString( _T( "GH2MakerXBox - *Unsaved Project" ) ) );


	            break ;
	        }
	    }

        ::wxRemoveFile( tempname ) ;

	}
}

void gh2makerFrame::OnCreateMidiButtonClick(wxCommandEvent& event)
{
    constructMidi( true ) ;
    Grid1->SetFocus() ;

}
extern wxSemaphore g_semProgress ;

void gh2makerFrame::OnSelectMidiButtonClick(wxCommandEvent& event)
{

    constructMidi( false ) ;
    Grid1->SetFocus() ;
}



void gh2makerFrame::constructOgg( bool forceConvert )
{
    wxString filename ;
    wxString tempname ;
    wxString line ;
    int      answer ;
    wxString artist ;
    wxString title ;
    long delay = 0 ;
    int quality = 3 ;


    wxFileDialog OpenDialog(
		this, forceConvert ? _( "Select the Song OGG file." ) : _("Select the OGG file."), m_source_ogg_dir, wxEmptyString,
		_("OGG files (*.ogg;*.mogg)|*.ogg;*.mogg||"),
		wxFD_OPEN|wxFD_CHANGE_DIR|wxFD_FILE_MUST_EXIST, wxDefaultPosition);

    OpenDialog.Center() ;

	if (OpenDialog.ShowModal() == wxID_OK)
	{

	    m_source_ogg_dir = OpenDialog.GetDirectory() ;

        OggFile ogg ;
        ogg.SetFile( OpenDialog.GetPath() ) ;

        artist = ogg.m_artist ;
        title = ogg.m_title ;

        if ( ( ! ( ogg.isValid() ) ) || forceConvert )
        {
            if ( !forceConvert )
            {
                answer = wxMessageBox( _T( "The OGG file is either not an OGG file or does not have 6 channels.\n\nThere's a good chance that it won't work correctly in its current state.\n\nDo you wish to allow GH2Maker to convert it into a usable format?\n\nIf you select \"No\" then it will be left as is and it will be added into your project.\n\nOnly select \"No\" if you really know what you're doing.\n\nSelect \"Cancel\" to abort this process altogether." ) ,
                                       _T( "OGG Failed Validation" ), wxCANCEL | wxYES_NO | wxICON_ERROR ) ;

                if ( answer == wxYES )
                {
                    forceConvert = true ;
                }
                else if ( answer == wxNO )
                {
                    filename = OpenDialog.GetPath() ;
                }
                else
                {
                    return ;
                }
            }

            if ( forceConvert )
            {
                int cfiles[6] ;
                int cchannels[6] ;

                CreateOggDialog oggDialog( this ) ;

                oggDialog.SetSourceDir( m_source_ogg_dir ) ;
                oggDialog.SetDestDir( m_dest_ogg_dir ) ;
                oggDialog.addOggFile( OpenDialog.GetPath(), 1, true ) ;
                if ( oggDialog.ShowModal() != wxOK )
                {
                    m_source_ogg_dir = oggDialog.GetSourceDir() ;
                    m_dest_ogg_dir = oggDialog.GetDestDir() ;
                    return ;
                }

                m_source_ogg_dir = oggDialog.GetSourceDir() ;
                m_dest_ogg_dir = oggDialog.GetDestDir() ;
                filename = oggDialog.TextCtrlOutputFile->GetValue() ;
                artist = oggDialog.TextCtrlArtist->GetValue() ;
                title = oggDialog.TextCtrlTitle->GetValue() ;
                if ( ! ( oggDialog.TextCtrlDelay->GetValue().ToLong( &delay ) ) )
                    delay = 0 ;
                quality = oggDialog.SliderOggQuality->GetValue() ;

                for ( int i = 0 ; i < 6 ; i++ )
                {
                    wxString item ;
                    long channel ;

                    switch( i )
                    {
                        case 0 : item = oggDialog.ComboSongL->GetValue() ; break ;
                        case 1 : item = oggDialog.ComboSongR->GetValue() ; break ;
                        case 2 : item = oggDialog.ComboGuitarL->GetValue() ; break ;
                        case 3 : item = oggDialog.ComboGuitarR->GetValue() ; break ;
                        case 4 : item = oggDialog.ComboRhythmL->GetValue() ; break ;
                        case 5 : item = oggDialog.ComboRhythmR->GetValue() ; break ;
                    }



                    if ( item.StartsWith( _T( "(S)" ) ) )
                        cfiles[i] = 0 ;
                    else if ( item.StartsWith( _T( "(G)" ) ) )
                        cfiles[i] = 1 ;
                    else if ( item.StartsWith( _T( "(R)" ) ) )
                        cfiles[i] = 2 ;

                    if ( item.AfterLast( ' ' ).ToLong( &channel ) )
                        cchannels[i] = channel - 1 ;

                }
                if ( oggDialog.CheckBoxDeferCreation->IsChecked() )
                {

                    m_construct_ogg[m_curr_row] = true ;
                    m_construct_ogg_delay[m_curr_row] = delay ;
                    m_construct_ogg_quality[m_curr_row] = quality ;

                    m_construct_ogg_source_files[m_curr_row][0] = oggDialog.m_ogg_song.m_filename ;
                    m_construct_ogg_source_files[m_curr_row][1] = oggDialog.m_ogg_guitar.m_filename ;
                    m_construct_ogg_source_files[m_curr_row][2] = oggDialog.m_ogg_rhythm.m_filename ;
                    m_construct_ogg_artist[m_curr_row] = artist ;
                    m_construct_ogg_title[m_curr_row] = title ;

                    for ( int i = 0 ; i < 6 ; i++ )
                    {
                        m_construct_ogg_channel_source[m_curr_row][i] = cfiles[i] ;
                        m_construct_ogg_channel_index[m_curr_row][i] = cchannels[i] ;
                    }

                }
                else
                {
                    OggMerger *merger ;

                    merger = new OggMerger() ;

                    ProgressDialog *progressDialog ;
                    progressDialog = new ProgressDialog( merger, this ) ;

                    progressDialog->SetTitle(  _T( "Permuting Ogg File" ) ) ;
                    progressDialog->Center() ;
                    merger->SetData( oggDialog.m_ogg_song.m_filename, oggDialog.m_ogg_guitar.m_filename,
                        oggDialog.m_ogg_rhythm.m_filename,
                        cfiles[0], cchannels[0], cfiles[1], cchannels[1],
                        cfiles[2], cchannels[2], cfiles[3], cchannels[3],
                        cfiles[4], cchannels[4], cfiles[5], cchannels[5],
                        oggDialog.TextCtrlOutputFile->GetValue(), artist,
                        title, delay, quality, progressDialog, progressDialog->GetId(), true ) ;


                    if ( progressDialog->ShowModal() != wxOK )
                    {
                        delete progressDialog ;
                        return ;
                    }

                    delete progressDialog ;


                }
            }
        }
        else
        {
            filename = OpenDialog.GetPath() ;
        }

        m_oggfile[m_curr_row] = filename ;
        TextOggControl->SetValue( filename ) ;
        Grid1->SetCellBackgroundColour( m_curr_row, 3, wxColor( 0x60, 0xF0, 0x60 ) ) ;
        Grid1->SetCellValue( m_curr_row, 3, m_construct_ogg[m_curr_row] ? _T("New/Convert") : _T("New") ) ;
        if ( artist.Length() > 0 )
            Grid1->SetCellValue( m_curr_row, 1, artist ) ;
        if ( title.Length() > 0 )
            Grid1->SetCellValue( m_curr_row, 0, title ) ;

        Grid1->Refresh() ;
        TextOggControl->Refresh() ;
        m_valid_ogg[m_curr_row] = 1 ;
        m_modified = true ;
        if ( m_project_filename.Length() > 0 )
            SetTitle( wxString( _T( "GH2MakerXBox - *" ) ).Append( wxFileName( m_project_filename ).GetFullName() ) ) ;
        else
            SetTitle( wxString( _T( "GH2MakerXBox - *Unsaved Project" ) ) );



	}
}



void gh2makerFrame::OnSelectOggButtonClick(wxCommandEvent& event)
{
    constructOgg( false ) ;
    Grid1->SetFocus() ;
}

void gh2makerFrame::OnCreateOggButtonClick(wxCommandEvent& event)
{
    constructOgg( true ) ;
    Grid1->SetFocus() ;

}

void gh2makerFrame::OnMenuFileNewProjectSelected(wxCommandEvent& event)
{
    initControls() ;
}

void gh2makerFrame::OnMenuOpenProjectSelected(wxCommandEvent& event)
{
    initControls() ;
    loadProject() ;
}

void gh2makerFrame::OnMenuDTBSettingsSelected(wxCommandEvent& event)
{
    DTBOptionsDialog *dlg ;

    dlg = new DTBOptionsDialog( this ) ;
    //dlg->SetSize( -1, -1, 500, 500 ) ;
    dlg->Center() ;

    dlg->Difficulty1TextCtrl->SetValue( m_dtb_difficulty_names[0] )  ;
    dlg->Difficulty2TextCtrl->SetValue( m_dtb_difficulty_names[1] )  ;
    dlg->Difficulty3TextCtrl->SetValue( m_dtb_difficulty_names[2] )  ;
    dlg->Difficulty4TextCtrl->SetValue( m_dtb_difficulty_names[3] )  ;

    dlg->AlwaysStarCheck->SetValue( m_dtb_always_star_power ) ;
    dlg->AutoPlayCheck->SetValue( m_dtb_auto_play ) ;
    dlg->EasyGuitarCheck->SetValue( m_dtb_easy_unlock_guitars );
    dlg->EncoreVenuesCheck->SetValue( m_dtb_encore_venues ) ;
    dlg->FreeStoreCheck->SetValue( m_dtb_free_store );
    dlg->SaveUnlockCheck->SetValue( m_dtb_enable_save_unlock_cheat ) ;
    dlg->CheckBoxRemoveOrange->SetValue( m_dtb_remove_orange ) ;


    dlg->Tier1TextCtrl->SetValue( m_dtb_tier_names[0] ) ;
    dlg->Tier2TextCtrl->SetValue( m_dtb_tier_names[1] ) ;
    dlg->Tier3TextCtrl->SetValue( m_dtb_tier_names[2] ) ;
    dlg->Tier4TextCtrl->SetValue( m_dtb_tier_names[3] ) ;
    dlg->Tier5TextCtrl->SetValue( m_dtb_tier_names[4] ) ;
    dlg->Tier6TextCtrl->SetValue( m_dtb_tier_names[5] ) ;
    dlg->Tier7TextCtrl->SetValue( m_dtb_tier_names[6] ) ;
    dlg->Tier8TextCtrl->SetValue( m_dtb_tier_names[7] ) ;

    dlg->Venue1TextCtrl->SetValue( m_dtb_venue_names[0] ) ;
    dlg->Venue2TextCtrl->SetValue( m_dtb_venue_names[1] ) ;
    dlg->Venue3TextCtrl->SetValue( m_dtb_venue_names[2] ) ;
    dlg->Venue4TextCtrl->SetValue( m_dtb_venue_names[3] ) ;
    dlg->Venue5TextCtrl->SetValue( m_dtb_venue_names[4] ) ;
    dlg->Venue6TextCtrl->SetValue( m_dtb_venue_names[5] ) ;
    dlg->Venue7TextCtrl->SetValue( m_dtb_venue_names[6] ) ;
    dlg->Venue8TextCtrl->SetValue( m_dtb_venue_names[7] ) ;

    dlg->NotePointsTextCtrl->SetValue( wxString::Format( _T("%d"), m_dtb_note_points ) ) ;
    dlg->SustainPointsTextCtrl->SetValue( wxString::Format( _T("%d"), m_dtb_sustain_points ) ) ;
    dlg->SlopTextCtrl->SetValue( wxString::Format( _T("%d"), m_dtb_slop ) ) ;
    dlg->HOPOTextCtrl->SetValue( wxString::Format( _T("%d"), m_dtb_hopo_threshold ) ) ;
    dlg->HardSpeedTextCtrl->SetValue( wxString::Format( _T("%1.5f"), (float)m_dtb_track_speed_hard/1000000.0f ) ) ;
    dlg->ExpertSpeedTextCtrl->SetValue( wxString::Format( _T("%1.5f"), (float)m_dtb_track_speed_expert/1000000.0f ) ) ;


    if ( dlg->ShowModal( ) == wxOK )
    {
        m_dtb_difficulty_names[0] = dlg->Difficulty1TextCtrl->GetValue(  )  ;
        m_dtb_difficulty_names[1] = dlg->Difficulty2TextCtrl->GetValue(  )  ;
        m_dtb_difficulty_names[2] = dlg->Difficulty3TextCtrl->GetValue(  )  ;
        m_dtb_difficulty_names[3] = dlg->Difficulty4TextCtrl->GetValue(  )  ;

        m_dtb_always_star_power = dlg->AlwaysStarCheck->GetValue() ;
        m_dtb_auto_play = dlg->AutoPlayCheck->GetValue(  ) ;
        m_dtb_easy_unlock_guitars = dlg->EasyGuitarCheck->GetValue( );
        m_dtb_encore_venues  = dlg->EncoreVenuesCheck->GetValue( ) ;
        m_dtb_free_store = dlg->FreeStoreCheck->GetValue( );
        m_dtb_enable_save_unlock_cheat  = dlg->SaveUnlockCheck->GetValue( ) ;
        m_dtb_remove_orange = dlg->CheckBoxRemoveOrange->GetValue() ;

        m_dtb_tier_names[0] = dlg->Tier1TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[1] = dlg->Tier2TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[2] = dlg->Tier3TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[3] = dlg->Tier4TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[4] = dlg->Tier5TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[5] = dlg->Tier6TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[6] = dlg->Tier7TextCtrl->GetValue(  ) ;
        m_dtb_tier_names[7] = dlg->Tier8TextCtrl->GetValue(  ) ;


        m_dtb_venue_names[0] = dlg->Venue1TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[1] = dlg->Venue2TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[2] = dlg->Venue3TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[3] = dlg->Venue4TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[4] = dlg->Venue5TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[5] = dlg->Venue6TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[6] = dlg->Venue7TextCtrl->GetValue(  ) ;
        m_dtb_venue_names[7] = dlg->Venue8TextCtrl->GetValue(  ) ;

        m_dtb_note_points = atoi( dlg->NotePointsTextCtrl->GetValue( ).char_str() ) ;
        m_dtb_sustain_points = atoi( dlg->SustainPointsTextCtrl->GetValue( ).char_str() ) ;
        m_dtb_slop = atoi( dlg->SlopTextCtrl->GetValue( ).char_str() ) ;
        m_dtb_hopo_threshold = atoi( dlg->HOPOTextCtrl->GetValue( ).char_str() ) ;
        m_dtb_track_speed_hard = (int)( atof( dlg->HardSpeedTextCtrl->GetValue( ).char_str() ) * 1000000.0f );
        m_dtb_track_speed_expert = (int)( atof( dlg->ExpertSpeedTextCtrl->GetValue( ).char_str() ) * 1000000.0f );

    }

    delete dlg ;
}

void gh2makerFrame::OnMenuSaveProjectAsSelected(wxCommandEvent& event)
{
    saveProject( true ) ;
}

void gh2makerFrame::OnMenuSaveProjectSelected(wxCommandEvent& event)
{
    saveProject( false ) ;
}


void gh2makerFrame::OnGrid1CellSelect(wxGridEvent& event)
{
    m_curr_row = event.GetRow() ;
    TextMidiControl->SetValue( m_midifile[m_curr_row] ) ;
    TextOggControl->SetValue( m_oggfile[m_curr_row] ) ;
    event.Skip(true) ;

}


void gh2makerFrame::OnButtonClearMidiClick(wxCommandEvent& event)
{
    OnButtonClearOggClick( event ) ;

}

void gh2makerFrame::OnButtonClearOggClick(wxCommandEvent& event)
{
    switch ( wxMessageBox( _T("Do you want to use small dummy files for this row?\n\nClick Yes to use small dummy files.\n\nClick No to set the row back to defaults.\n\nClick Cancel to abort"), _T("Select Clear Method"), wxYES_NO | wxCANCEL) )
    {
        case wxCANCEL : return ;
        case wxYES :
        {
            Grid1->SetCellBackgroundColour( m_curr_row, 2, wxColor( 0xF0, 0xF0, 0x00 ) ) ;
            Grid1->SetCellValue( m_curr_row, 0, _T("BLANK") ) ;
            Grid1->SetCellValue( m_curr_row, 1, _T("BLANK") ) ;
            Grid1->SetCellValue( m_curr_row, 2, _T("Blank") ) ;
            m_valid_midi[m_curr_row] = 2;
            Grid1->SetCellBackgroundColour( m_curr_row, 3, wxColor( 0xF0, 0xF0, 0x00 ) ) ;
            Grid1->SetCellValue( m_curr_row, 3, _T("Blank") ) ;
            m_valid_ogg[m_curr_row] = 2 ;
            break ;
        }
        case wxNO:
        {
            Grid1->SetCellValue( m_curr_row, 0, _T("") ) ;
            Grid1->SetCellValue( m_curr_row, 1, _T("") ) ;
            Grid1->SetCellBackgroundColour( m_curr_row, 2, wxColor( 0xF0, 0x60, 0x60 ) ) ;
            Grid1->SetCellValue( m_curr_row, 2, _T("Existing") ) ;
            m_valid_midi[m_curr_row] = 0;
            Grid1->SetCellBackgroundColour( m_curr_row, 3, wxColor( 0xF0, 0x60, 0x60 ) ) ;
            Grid1->SetCellValue( m_curr_row, 3, _T("Existing") ) ;
            m_valid_ogg[m_curr_row] = 0 ;
            break ;
        }
    }

    m_construct_ogg[m_curr_row] = false ;
    m_construct_ogg_source_files[m_curr_row][0] = _T("") ;
    m_construct_ogg_source_files[m_curr_row][1] = _T("") ;
    m_construct_ogg_source_files[m_curr_row][2] = _T("") ;
    m_construct_ogg_artist[m_curr_row] = _T("") ;
    m_construct_ogg_title[m_curr_row] = _T("") ;

    for ( int i = 0 ; i < 6 ; i++ )
    {
        m_construct_ogg_channel_source[m_curr_row][i] = 0 ;
        m_construct_ogg_channel_index[m_curr_row][i] = 0 ;
    }



    m_construct_midi[m_curr_row] = 0 ;
    m_midifile[m_curr_row] = _T("") ;
    m_oggfile[m_curr_row] = _T("") ;
    TextOggControl->SetValue( _T("")) ;
    TextMidiControl->SetValue( _T("")) ;
    TextOggControl->Refresh() ;
    TextMidiControl->Refresh() ;
    Grid1->Refresh() ;
    m_modified = true ;
    if ( m_project_filename.Length() > 0 )
        SetTitle( wxString( _T( "GH2MakerXBox - *" ) ).Append( wxFileName( m_project_filename ).GetFullName() ) ) ;
    else
        SetTitle( wxString( _T( "GH2MakerXBox - *Unsaved Project" ) ) );


    Grid1->SetFocus() ;
}
void gh2makerFrame::OnButtonFinalizeClick(wxCommandEvent& event)
{
    FinalizerThread *creator ;

    g_num_converted_ogg  = 0 ;
    g_frame = this ;

    creator = new FinalizerThread() ;

    ProgressDialog *progressDialog ;
    progressDialog = new ProgressDialog( creator, this ) ;

    progressDialog->Center() ;
    progressDialog->SetTitle(  _T( "Finalizing Guitar Hero 2 ARK/HDR  Files" ) ) ;

    creator->SetData( progressDialog, progressDialog->GetId() ) ;

    if ( progressDialog->ShowModal() != wxOK )
    {
        delete progressDialog ;
        return ;
    }

    delete progressDialog ;

    if ( g_num_converted_ogg )
    {
        wxMessageBox( wxT("Some OGGs were successfully converted.  It would be a good idea to save your project so that they aren't re-converted the next time you make the ARK." ) ) ;
        m_modified = true ;
        if ( m_project_filename.Length() > 0 )
            SetTitle( wxString( _T( "GH2MakerXBox - *" ) ).Append( wxFileName( m_project_filename ).GetFullName() ) ) ;
        else
            SetTitle( wxString( _T( "GH2MakerXBox - *Unsaved Project" ) ) );
    }

    Grid1->SetFocus() ;

}

void gh2makerFrame::OnMenuItemClearLineSelected(wxCommandEvent& event)
{
    Grid1->SetCellBackgroundColour( m_curr_row, 2, wxColor( 0xF0, 0xF0, 0x00 ) ) ;
    Grid1->SetCellValue( m_curr_row, 0, _T("BLANK") ) ;
    Grid1->SetCellValue( m_curr_row, 1, _T("BLANK") ) ;
    Grid1->SetCellValue( m_curr_row, 2, _T("Blank") ) ;
    m_valid_midi[m_curr_row] = 2;
    Grid1->SetCellBackgroundColour( m_curr_row, 3, wxColor( 0xF0, 0xF0, 0x00 ) ) ;
    Grid1->SetCellValue( m_curr_row, 3, _T("Blank") ) ;
    m_valid_ogg[m_curr_row] = 2 ;

    m_construct_ogg[m_curr_row] = false ;
    m_construct_ogg_source_files[m_curr_row][0] = _T("") ;
    m_construct_ogg_source_files[m_curr_row][1] = _T("") ;
    m_construct_ogg_source_files[m_curr_row][2] = _T("") ;
    m_construct_ogg_artist[m_curr_row] = _T("") ;
    m_construct_ogg_title[m_curr_row] = _T("") ;

    for ( int i = 0 ; i < 6 ; i++ )
    {
        m_construct_ogg_channel_source[m_curr_row][i] = 0 ;
        m_construct_ogg_channel_index[m_curr_row][i] = 0 ;
    }


    m_construct_midi[m_curr_row] = 0 ;
    m_midifile[m_curr_row] = _T("") ;
    m_oggfile[m_curr_row] = _T("") ;
    TextOggControl->SetValue( _T("")) ;
    TextMidiControl->SetValue( _T("")) ;
    TextOggControl->Refresh() ;
    TextMidiControl->Refresh() ;
    Grid1->Refresh() ;
    m_modified = true ;
    if ( m_project_filename.Length() > 0 )
        SetTitle( wxString( _T( "GH2MakerXBox - *" ) ).Append( wxFileName( m_project_filename ).GetFullName() ) ) ;
    else
        SetTitle( wxString( _T( "GH2MakerXBox - *Unsaved Project" ) ) );


    Grid1->SetFocus() ;
}

void gh2makerFrame::OnMenuItemRevalidateSelected(wxCommandEvent& event)
{
    for ( int i = 0 ; i < 74 ; i++ )
    {
        if ( ( m_valid_ogg[i] == 1 ) && ( m_construct_ogg[i] ) )
        {
            OggFile ogg ;
            ogg.SetFile( m_oggfile[i] ) ;

            if ( ogg.isValid() )
            {
                m_construct_ogg[i] = 0 ;
                Grid1->SetCellValue( i, 3, _T("New") ) ;
            }
        }
    }
}
