/***************************************************************
 * Name:      gh2makerMain.h
 * Purpose:   Defines Application Frame
 * Author:     ()
 * Created:   2008-04-10
 * Copyright:  ()
 * License:
 **************************************************************/

#ifndef GH2MAKERMAIN_H
#define GH2MAKERMAIN_H

#include "arktool/ArkHdrPair.h"

//(*Headers(gh2makerFrame)
#include <wx/stattext.h>
#include <wx/menu.h>
#include <wx/textctrl.h>
#include <wx/grid.h>
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/statusbr.h>
//*)

class gh2makerFrame: public wxFrame
{
    public:

        gh2makerFrame(wxWindow* parent,wxWindowID id = -1);
        virtual ~gh2makerFrame();

    private:

        //(*Handlers(gh2makerFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnGrid1CellLeftClick(wxGridEvent& event);
        void OnCreateMidiButtonClick(wxCommandEvent& event);
        void OnSelectArkButtonClick(wxCommandEvent& event);
        void OnSelectMidiButtonClick(wxCommandEvent& event);
        void OnSelectOggButtonClick(wxCommandEvent& event);
        void OnCreateOggButtonClick(wxCommandEvent& event);
        void OnMenuFileNewProjectSelected(wxCommandEvent& event);
        void OnMenuOpenProjectSelected(wxCommandEvent& event);
        void OnMenuDTBSettingsSelected(wxCommandEvent& event);
        void OnMenuSaveProjectAsSelected(wxCommandEvent& event);
        void OnMenuSaveProjectSelected(wxCommandEvent& event);
        void OnGrid1CellSelect(wxGridEvent& event);
        void OnButtonFinalizeClick(wxCommandEvent& event);
        void OnButtonClearMidiClick(wxCommandEvent& event);
        void OnButtonClearOggClick(wxCommandEvent& event);
        void OnMenuItemClearLineSelected(wxCommandEvent& event);
        void OnMenuItemRevalidateSelected(wxCommandEvent& event);
        //*)

        void initControls() ;
        void importArkData() ;
        int setGridCellDTB( int row, int col, char *dtbentry );
        int loadProject() ;
        int saveProject( bool forceSave) ;
        void constructMidi( bool forceConvert ) ;
        void constructOgg( bool forceConvert ) ;
        void OnSetFocus(wxFocusEvent &event) ;

        //(*Identifiers(gh2makerFrame)
        static const long ID_GRID1;
        static const long ID_TEXTCTRL3;
        static const long ID_TEXTCTRL2;
        static const long ID_TEXTCTRL1;
        static const long ID_STATICTEXT3;
        static const long ID_STATICTEXT1;
        static const long ID_STATICTEXT2;
        static const long ID_BUTTON5;
        static const long ID_BUTTON3;
        static const long ID_BUTTON4;
        static const long ID_BUTTON1;
        static const long ID_BUTTON2;
        static const long ID_BUTTON6;
        static const long ID_BUTTON8;
        static const long ID_BUTTON7;
        static const long idMenuFileNew;
        static const long idMenuOpenProject;
        static const long idFileSaveProject;
        static const long idFileSaveProjectAs;
        static const long idMenuDTBSettings;
        static const long idSelectARK;
        static const long idCreateMIDI;
        static const long idCreateOGG;
        static const long idClearLine;
        static const long idRevalidateOGGs;
        static const long idMenuQuit;
        static const long idMenuAbout;
        static const long ID_STATUSBAR1;
        //*)

public:
        wxString m_midifile[74] ;
        wxString m_oggfile[74] ;
        int m_valid_ogg[74] ;
        int m_valid_midi[74] ;
        bool m_construct_midi[74] ;

        bool m_construct_ogg[74] ;
        wxString m_construct_ogg_source_files[74][3] ;
        int m_construct_ogg_channel_source[74][6] ;
        int m_construct_ogg_channel_index[74][6] ;
        int m_construct_ogg_delay[74] ;
        wxString m_construct_ogg_title[74] ;
        wxString m_construct_ogg_artist[74] ;
        int m_construct_ogg_quality[74] ;


        int m_curr_row ;
        bool m_modified ;

        int m_dtb_note_points ;
        int m_dtb_sustain_points ;
        int m_dtb_easy_unlock_guitars ;
        int m_dtb_encore_venues ;
        int m_dtb_always_star_power ;
        int m_dtb_free_store ;
        int m_dtb_track_speed_hard ;
        int m_dtb_track_speed_expert ;
        int m_dtb_enable_save_unlock_cheat ;
        int m_dtb_auto_play ;
        int m_dtb_slop ;
        int m_dtb_hopo_threshold ;
        int m_dtb_remove_orange ;

        wxString m_dtb_tier_names[8] ;
        wxString m_dtb_venue_names[8] ;
        wxString m_dtb_difficulty_names[4] ;


        ArkHdrPair m_arkhdr ;
        wxString   m_arkdir ;
        wxString   m_project_dir ;
        wxString   m_source_midi_dir ;
        wxString   m_dest_midi_dir ;
        wxString   m_source_ogg_dir ;
        wxString   m_dest_ogg_dir ;
        wxString   m_project_filename ;

        //(*Declarations(gh2makerFrame)
        wxButton* CreateOggButton;
        wxMenuItem* MenuSaveProjectAs;
        wxMenuItem* MenuItemRevalidate;
        wxButton* ButtonClearOgg;
        wxButton* CreateMidiButton;
        wxTextCtrl* TextOggControl;
        wxMenuItem* MenuItem5;
        wxStaticText* StaticText2;
        wxMenuItem* MenuItem4;
        wxTextCtrl* TextArkControl;
        wxStaticText* StaticText1;
        wxStaticText* StaticText3;
        wxGrid* Grid1;
        wxButton* SelectMidiButton;
        wxMenu Menu3;
        wxButton* SelectOggButton;
        wxButton* SelectArkButton;
        wxMenuItem* MenuItem3;
        wxStatusBar* StatusBar1;
        wxButton* ButtonFinalize;
        wxMenuItem* MenuItem6;
        wxButton* ButtonClearMidi;
        wxTextCtrl* TextMidiControl;
        wxMenuItem* MenuFileNewProject;
        wxMenuItem* MenuOpenProject;
        wxMenuItem* MenuSaveProject;
        wxMenuItem* MenuDTBSettings;
        //*)

        DECLARE_EVENT_TABLE()
};

#endif // GH2MAKERMAIN_H
